#include "Copyright.h"
#include "Camera.h"
#include "Walker.h"
#include "Sector.h"





BCamera::BCamera () :
    m_vpoint   (),
    m_vnormal  (),
    m_vlevel   (0.0f),
    m_vsector  (BNULL),
    m_costheta (0.0f),
    m_sintheta (0.0f)   {}




BCamera::BCamera (const BWalker & walker) :
    m_vpoint   (walker.m_pos),
    m_vnormal  (walker.m_normal),
    m_vlevel   (walker.m_sector->m_floorlevel + walker.m_height),
    m_vsector  (walker.m_sector),
    m_costheta (walker.m_normal.x / walker.m_normal.Length ()),
    m_sintheta (walker.m_normal.y / walker.m_normal.Length ())   {}

    


void BCamera::SetView (const BPoint  & vpoint,
                       const BVector & vnormal,
                       const BREAL     vlevel,
                       const BSector * vsector) {

    m_vsector  = vsector;
    m_vpoint   = vpoint;
    m_vlevel   = vlevel;
    m_vnormal  = vnormal;
    m_costheta = vnormal.x / vnormal.Length ();
    m_sintheta = vnormal.y / vnormal.Length ();
}





void BCamera::SetViewpoint  (const BPoint  & vpoint)
    {m_vpoint = vpoint;}


void BCamera::SetViewlevel  (BREAL vlevel)
    {m_vlevel = vlevel;}


void BCamera::SetViewnormal (const BVector & vnormal) {
    m_vnormal  = vnormal;
    m_costheta = vnormal.x / vnormal.Length ();
    m_sintheta = vnormal.y / vnormal.Length ();
    }


void BCamera::SetViewsector (const BSector * vsector)
    {m_vsector = vsector;}




void BCamera::Report () const {
    return;
}


