#ifndef  _CAMERA_H
#define  _CAMERA_H


#ifndef  _BALDEF_H
#include "BalDef.h"
#endif

#ifndef  _POINT_H
#include "Point.h"
#endif

#ifndef  _VECTOR_H
#include "Vector.h"
#endif



class BRengine;
class BSector;
class BWalker;




class BCamera {
friend class BRengine;

private:
    BPoint          m_vpoint;
    BREAL           m_vlevel;
    const BSector * m_vsector;
    BVector         m_vnormal;
    BREAL           m_costheta;
    BREAL           m_sintheta;


public:
    BCamera ();
    BCamera (const BWalker & walker);


    void SetView (const BPoint  & vpoint,
                  const BVector & vnormal,
                  const BREAL     vlevel,
                  const BSector * vsector);


    void SetViewpoint  (const BPoint  & vpoint);
    void SetViewlevel  (BREAL vlevel);
    void SetViewsector (const BSector * vsector);
    void SetViewnormal (const BVector & vnormal); 


    void Report () const;
};


#endif
