#include <math.h>
#include <malloc.h>
#include "shared.h"
#include "stuff.h"
#include "fmath\fmath.h"
#include "3de\3d.h"
#include "handlers\handlers.h"
#include "trivesa.h"
#include "vesa\vesa.h"
#include "3dsrdr.h"
#include "..\matlib\matlib.h"

object3DE *o;
word *t,*bkgr;
byte *tmp,*bumpmap;
int k,l;
word *bbufr[2],bufrno=0;
byte *remap;
// fps stuff
dword frames=0,start,fps;
dword *clock=(dword *)0x0000046CL;
// misc stuff
int mousex,mousey,mouseb,i,j,ij,x,y,blur=0,automove=0,tst=0,i1,i2,i3,fn;
int anx=0,any=0,speed=0,strafespeed=0,mousex,mousey,mouseb,r,g,b;

///////////////////////////////////////////////////////////////////
word *spotr,*spotg,*spotb,*spot;
byte *rgbadd32,*rgbadd64;

void precalc(void){
   int i,j,k,r,g,b;
   spot=(word *)malloc(65536*2);
   spotr=(word *)malloc(65536*2);
   spotg=(word *)malloc(65536*2);
   spotb=(word *)malloc(65536*2);
   rgbadd32=(byte *)malloc(32*32);
   rgbadd64=(byte *)malloc(64*64);
   for (j=0;j<256;j++)
       for (i=0;i<256;i++){
           k=255-(sqrt(((128-i)*(128-i))+((128-j)*(128-j)))*8);
           if (k<0) k=0;
           spot[j*256+i]=colormask(k,k,k);
           spotr[j*256+i]=colormask(k,k,k);
           spotg[j*256+i]=colormask(k,k,k);
           spotb[j*256+i]=colormask(k,k,k);
   }
   for (j=0;j<256;j++)
       for (i=0;i<256;i++){
           k=255-(sqrt(((128-i)*(128-i))+((128-j)*(128-j)))*2);
           if (k<0) k=0;
           l=colormask(k,k,k)+spot[j*256+i];
           if (l>65535) l=65535;
           spot[j*256+i]=l;
           l=spotr[j*256+i]; spotr[j*256+i]=(l&(65535-32768-16384-8192-4096-2048))+((k>>3)<<11);
           l=spotg[j*256+i]; spotg[j*256+i]=(l&(65535-1024-512-256-128-64-32))+((k>>2)<<5);
           l=spotb[j*256+i]; spotb[j*256+i]=(l&(65535-16-8-4-2-1))+(k>>3);
   }
   for (i=0;i<32;i++)
       for (j=0;j<32;j++){
           l=i+j;
           if (l>31) l=31;
           rgbadd32[i*32+j]=l;
       }
   for (i=0;i<64;i++)
       for (j=0;j<64;j++){
           l=i+j;
           if (l>63) l=63;
           rgbadd64[i*64+j]=l;
       }
}

void light(int x,int y,int lx,word *s){
   int i,j,k,l,r,g,b,ly;
   int ix,sx,px,py,p;

   if (lx<0) return;
   x-=(lx>>1);
   y-=(lx>>1);
   if ((y>clipy2+lx)||(x>clipx2+lx)||y<(-lx+clipy1)||(x<-lx+clipx1)) return;
   ix=(256<<16)/lx;
   ly=lx;
   sx=0;
   px=0;
   py=0;
   if (y<clipy1){
       py+=(clipy1-y)*ix;
       ly-=clipy1-y;
       y=clipy1;
   }
   if (x<clipx1){
       sx+=(clipx1-x)*ix;
       px=sx;
       lx-=clipx1-x;
       x=clipx1;
   }
   if (x+lx>clipx2) lx-=x+lx-clipx2;
   if (y+ly>clipy2) ly-=y+ly-clipy2;
   for (i=0;i<ly;i++){
       p=(y+i)*320+x;
       for (j=0;j<lx;j++){
           k=VESAbufrw[p];
           l=s[((py>>16)<<8)+(px>>16)];
           r=rgbadd32[(((k&63488)>>11)*32+((l&63488)>>11))];
           g=rgbadd64[(((k&2016)>>5)*64+((l&2016)>>5))];
           b=rgbadd32[(((k&31))*32+((l&31)))];
           VESAbufrw[p]=(r<<11)+(g<<5)+b;
           p++;
           px+=ix;
       }
       px=sx;
       py+=ix;
   }
}
///////////////////////////////////////////////////////////////////
int VGArefresh;

#pragma aux gettimerfreq=\
        "xor ecx,ecx"\
        "cli"\
        "mov al,34h"\
        "out 43h,al"\
        "mov al,0"\
        "out 40h,al"\
        "out 40h,al"\
        "mov edx,3dah",\
        "wait1:",\
        "in al,dx",\
        "test al,8",\
        "jz wait1",\
        "wait2:",\
        "in al,dx",\
        "test al,8",\
        "jnz wait2",\
        "mov al,0"\
        "out 43h,al"\
        "in al,40h"\
        "mov cl,al"\
        "in al,40h"\
        "mov ch,al"\
        "mov edx,3dah",\
        "wait3:",\
        "in al,dx",\
        "test al,8",\
        "jz wait3",\
        "wait4:",\
        "in al,dx",\
        "test al,8",\
        "jnz wait4",\
        "mov al,0"\
        "out 43h,al"\
        "in al,40h"\
        "mov dl,al"\
        "in al,40h"\
        "mov dh,al"\
        "sub cx,dx"\
        "sti"\
        value [ecx] modify [eax ebx ecx edx];
///////////////////////////////////////////////////////////////////

void pmove(int nb,dword ax,dword ay){
   int tx,ty,pos;
   ax&=1023;
   ay&=1023;
   cam->pos[0]+=(fsint[ay]*nb)>>8;
   cam->pos[2]-=(fcost[ay]*nb)>>8;
}

void render(void){
   object3DE *ob;
   camera3DE *cm;
   light3DE *ls;
   vect v;
   int c,c1,c2,c3,a1,a2,a3,*type,size;
   for (i=0;i<=nbfv;i++){
       type=zdepth[i].o;
       switch (type[0]){
           case LIGHT:
               ls=zdepth[i].o;
               size=fixdiv(2<<24,ls->posrot[2])>>16;
           //    light(ls->proj[0],ls->proj[1],size,spot);
               break;
           case OBJECT:
               ob=zdepth[i].o;
               fn=zdepth[i].fn;
               i1=ob->fc[fn].i1;
               i2=ob->fc[fn].i2;
               i3=ob->fc[fn].i3;
               _VESAtri.x1=ob->proj[i1][0]; 
               _VESAtri.y1=ob->proj[i1][1];
               _VESAtri.z1=ob->ptsrot[i1][2];
               _VESAtri.x2=ob->proj[i2][0]; 
               _VESAtri.y2=ob->proj[i2][1];
               _VESAtri.z2=ob->ptsrot[i2][2];
               _VESAtri.x3=ob->proj[i3][0]; 
               _VESAtri.y3=ob->proj[i3][1];
               _VESAtri.z3=ob->ptsrot[i3][2];
               _VESAtri.tx1=ob->fc[fn].u1; 
               _VESAtri.ty1=ob->fc[fn].v1;
               _VESAtri.tx2=ob->fc[fn].u2; 
               _VESAtri.ty2=ob->fc[fn].v2;
               _VESAtri.tx3=ob->fc[fn].u3; 
               _VESAtri.ty3=ob->fc[fn].v3;
               _VESAtri.nx1=(ob->pnormsrot[i1][0]>>6);
               _VESAtri.ny1=(ob->pnormsrot[i1][1]>>6);
               _VESAtri.nz1=(ob->pnormsrot[i1][2]>>6);
               _VESAtri.nx2=(ob->pnormsrot[i2][0]>>6);
               _VESAtri.ny2=(ob->pnormsrot[i2][1]>>6);
               _VESAtri.nz2=(ob->pnormsrot[i2][2]>>6);
               _VESAtri.nx3=(ob->pnormsrot[i3][0]>>6);
               _VESAtri.ny3=(ob->pnormsrot[i3][1]>>6);
               _VESAtri.nz3=(ob->pnormsrot[i3][2]>>6);
        //       _VESAtri.pic=ob->fc[fn].texture;
        //       _VESAtri.bumpmap=ob->fc[fn].bumpmap;
               // overhide
               _VESAtri.pic=t;
               _VESAtri.bumpmap=bumpmap;

               subvector(lsrc->pos,ob->pts[i1],v); 
               vectornormalize(v);
               c=vectordot(v,ob->normsrot[fn])>>8;

               subvector(lsrc->pos,ob->pts[i1],v); 
               vectornormalize(v);
               c1=vectordot(v,ob->pnormsrot[i1])>>8;

               subvector(lsrc->pos,ob->pts[i2],v); 
               vectornormalize(v);
               c2=vectordot(v,ob->pnormsrot[i2])>>8;

               subvector(lsrc->pos,ob->pts[i3],v); 
               vectornormalize(v);
               c3=vectordot(v,ob->pnormsrot[i3])>>8;

               if (c>255) c=255; if (c<0) c=0;
               if (c1>255) c1=255; if (c1<0) c1=0;
               if (c2>255) c2=255; if (c2<0) c2=0;
               if (c3>255) c3=255; if (c3<0) c3=0;
               if (a1>511) a1=511; if (a1<-511) a1=-511;
               if (a2>511) a2=511; if (a2<-511) a2=-511;
               if (a3>511) a3=511; if (a3<-511) a3=-511;
               _VESAtri.c=c;
               _VESAtri.c1=c1;
               _VESAtri.c2=c2;
               _VESAtri.c3=c3;
               _VESAtri.a1=facost[a1+512];
               _VESAtri.a2=facost[a2+512];
               _VESAtri.a3=facost[a3+512];
               switch(tst){
                   case 0: pseudo3DE=0; ob->fc[fn].method=VESAtri_texture; break;
                   case 1: pseudo3DE=0; ob->fc[fn].method=VESAtri_pstexture; break;
                   case 2: pseudo3DE=0; ob->fc[fn].method=zVESAtri_texture; break;
                   case 3: pseudo3DE=1; ob->fc[fn].method=VESAtri_gtexture; break;
                   case 4: pseudo3DE=1; ob->fc[fn].method=VESAtri_ptexture; break;
                   case 5: pseudo3DE=1; ob->fc[fn].method=VESAtri_bptexture; break;
               }
               ob->fc[fn].method();
       }
   }
}

void handle_keys(void){
   if (keys[42]&4){ blur++; if (blur>2) blur=0; keys[42]=0; }
   if (keys[43]&4){ automove^=1; keys[43]=0; }
   if (keys[29]&4){ tst++; if (tst>5) tst=0; keys[29]=0; }

   if (keys[77]&2){ any+=4; cam->dir[1]-=4; }
   if (keys[75]&2){ any-=4; cam->dir[1]+=4; }
   if (keys[72]&2){ anx-=4; cam->dir[0]-=4; }
   if (keys[80]&2){ anx+=4; cam->dir[0]+=4; }
   if (keys[44]&2){ speed++; if (speed>32) speed=32; }
       else if (keys[45]&2) { speed--; if (speed<-32) speed=-32; }
           else if (speed>0) speed--; else if (speed<0) speed++;
   if (speed) pmove(speed,anx,any);
   
   if (keys[16]&2) cam->pos[0]+=256*16;
   if (keys[30]&2) cam->pos[0]-=256*16;
   if (keys[17]&2) cam->pos[1]+=256*16;
   if (keys[31]&2) cam->pos[1]-=256*16;
   if (keys[18]&2) cam->pos[2]+=256*16;
   if (keys[32]&2) cam->pos[2]-=256*16;
   if (keys[210]&2) o->pos[0]+=256*32;
   if (keys[211]&2) o->pos[0]-=256*32;
   if (keys[199]&2) o->pos[1]+=256*32;
   if (keys[207]&2) o->pos[1]-=256*32;
   if (keys[201]&2) o->pos[2]+=256*32;
   if (keys[209]&2) o->pos[2]-=256*32;
   
   if (keys[0x44]&2){
       for (i=0;i<o->nbfc;i++){
           o->fc[i].v1=(o->fc[i].v1+1)&255;
           o->fc[i].v2=(o->fc[i].v2+1)&255;
           o->fc[i].v3=(o->fc[i].v3+1)&255;
           o->fc[i].u1=(o->fc[i].u1+1)&255;
           o->fc[i].u2=(o->fc[i].u2+1)&255;
           o->fc[i].u3=(o->fc[i].u3+1)&255;
       }
   }
}

int calcslopetexture(int x1,int y1,int tx1,int ty1);
#pragma aux calcslopetexture "_*" parm [eax] [ebx] value [eax];

void main(int ac,char **av){
   rgb=(byte *)malloc(64*256);
   set_rgb_stable(128,0.70);
   printinfo_3de();
   printf("  press <Ctrl> to change rendering method\n  press <Shift> to change motion blur type.\n");
   printf(" initializing VESA driver\n");
   if (!VESAgetinfo()){
       printf("%s",VESAerrormessage);
       exit(0);
   }
   printf(" initializing renderer\n");
   init_VESAtrih();
   printf(" initializing math lib\n");
   init_fmath();
   
   o=loadASC(av[1]);
   if (o==NULL) out("object not found.",2);

/*
   load3DS(av[1]);
   o=ob[0];
   i=0;
   totalfaces=0;
   while (ob[i]!=NULL) totalfaces+=ob[i++]->nbfc;
   printf("%i total faces\n",totalfaces);
*/   
   init_3de();
   attach_object(o,world,0,0,0);
/*
   i=0;
   while (ob[i]!=NULL) attach_object(ob[i++],world,0,0,0);
*/
   t=(word *)malloc(256*256*2);
   bkgr=(word *)malloc(320*240*2);
   tmp=(byte *)malloc(320*240*4);
   bumpmap=(byte *)malloc(256*256);
   load_raw("bumpmap.raw",bumpmap,pal);
   for (i=0;i<8;i++) smooth(bumpmap,256,256);
   load_bin(av[2],tmp,32,0);

   setvector(o->pos,0,0,4096<<8);
   setvector(cam->pos,0,0,0);
   setvector(cam->dir,0,0,0);
   setvector(lsrc->pos,0,0,0);

   lsrc->pos[0]=o->pos[0];
   lsrc->pos[1]=o->pos[1];
   lsrc->pos[2]=o->pos[2]*2;

   specular=(byte *)malloc(65536);
   bmpspec=(byte *)malloc(65536);
   set_phong_lookup(specular,bmpspec);

   printf(" installing divide by 0 handler\n");
   printf(" installing keyboard handler\n");
   i=VESAsearchmode(320,240,16);
   if (i==0){
       printf("VESA mode 320x240x65536 colors unavaible, retry with UniVBE 5.0+");
       exit(0);
   }
   printf(" using VBE mode 0x%04x with %s\n",i,VESAlinear?"linear framebuffer\n":"banked framebuffer\n");
   getch();
   if (!VESAsetmode(i)){
       printf("%s",VESAerrormessage);
       exit(0);
   }
   
   i=gettimerfreq();
   VGArefresh=1193180/i;

   bbufr[0]=(word *)malloc(VESAsize);
   bbufr[1]=(word *)malloc(VESAsize);
   VESAbufr=(byte *)bbufr[0];
   zbuffer=(dword *)malloc(VESAsize*2);
   VESAbufrw=(word *)VESAbufr;
   repstosd(bbufr[0],0,VESAsize/4);
   repstosd(bbufr[1],0,VESAsize/4);
///////////////////////////////////////////////////////////////////
   precalc();
   init_motionblur(156);
///////////////////////////////////////////////////////////////////
                    
   l=0;
   for (i=0;i<65536;i++)
       t[i]=colormask(tmp[l++],tmp[l++],tmp[l++]);
   load_bin("backgrnd.raw",tmp,32,0);
   k=l=0;
   for (i=0;i<320;i++)
       for (j=0;j<240;j++){
           bkgr[k]=colormask(tmp[l++],tmp[l++],tmp[l++]);
           k++;
       }

   scrX=320;
   scrY=240;
   clipx1=0;
   clipy1=0;
   clipx2=319;
   clipy2=239;
   repstosd(VESAbufr,0,VESAsize/4);
   
   install_handlers();
   kb_init();
   start=*clock;
   while (!keys[1]){
       mouse(&mouseb,&mousex,&mousey);
       mouse2(&mousex,&mousey);
       if (automove){
           o->dir[0]+=2;
           o->dir[1]+=4;
           o->dir[2]+=8;
       } else {
           o->dir[0]+=mousex;
           o->dir[1]+=mousey;
           o->dir[2]+=mouseb*8;
       }

       nbfv=-1;
       calc_camera_matrix();
       rotate(world);
       if (nbfv>0) quicksort(0,nbfv);
       render();

       handle_keys();
       retrace();
       switch (blur){
           case 1: motionblur(bbufr[bufrno],bbufr[bufrno^1],scrX*scrY); break;
           case 2: motionblur2(bbufr[bufrno],bbufr[bufrno^1],scrX*scrY,blur1,blur2); break;
       }

       if (VESAlinear){
           repmovsd(bbufr[bufrno],linearbuffer,VESAsize/4);
       } else {
           VESAscreenswap((byte *)bbufr[bufrno],VESAwidth,VESAheight,VESAbpp);
       }
       bufrno^=1;
       VESAbufr=(byte *)bbufr[bufrno];
       VESAbufrw=(word *)bbufr[bufrno];
       repstosd(VESAbufr,0,VESAsize/4);
//       repmovsd(bkgr,VESAbufr,VESAsize/4);
       if (tst==2) repstosd(zbuffer,0x0,VESAsize/2);

//       lsrc->pos[0]=o->pos[0];
//       lsrc->pos[1]=o->pos[1];
//       lsrc->pos[2]=o->pos[2]*2;
       
       frames++;
       if (*clock-start>=18){
           fps=frames;
           frames=0;
           start=*clock;
       }
       for (i=0;i<fps;i++) VESAbufrw[239*320+i]=(16<<11)+(32<<5)+16;
       VESAbufrw[239*320]=65535;
       VESAbufrw[239*320+VGArefresh]=65535;
       VESAbufrw[239*320+(VGArefresh>>1)]=65535;
   }
   vmode(3);
   kb_flush();
   remove_handlers();
   printinfo_3de();
   printinfo_fmath();
   printinfo_gfx();
   printinfo_vesa();
   printf("\nCoded by deks/incamaster\n");
   printf("%ifps @ %iHz\n",fps,VGArefresh);
   printf("\nHierarchical tree info (%i):\n",pseudo3DE);
   worldinfo(world);
}

void worldinfo(object3DE *o){
   int thisnode;
   printf("%*s%s childs: %i\n",o->level*4,"",typenames[o->type],o->nbchilds);
   thisnode=0;
   while (thisnode<o->nbchilds) worldinfo(o->childs[thisnode++]);
}

void attach_object(void *_c,void *_p,int dx,int dy,int dz){
   int child,i,j;
   object3DE *c,*p;
   
   c=_c;
   p=_p;

   c->level=p->level+1;
   c->parent=p;
// dcale l'objet par rapport  son parent
   dx+=p->link[0];
   dy+=p->link[1];
   dz+=p->link[2];
   c->link[0]=dx;
   c->link[1]=dy;
   c->link[2]=dz;
   child=p->nbchilds;
   c->child=child;
   p->childs[child]=c;
   p->nbchilds++;
}
