/*--------------------------------------------------------------------------
                        THE CHAOS ENGINE - GFX.C

--------------------------------------------------------------------------*/

#define MODES 3
#define MODE13 0
#define MODEX320X240 1
#define MODEX320X400 2

#define GFXMODE_MODE13 1
#define GFXMODE_MODEX 2
#define GFXMODE_VESA 4

//-- Structures -------------------------------------------------------------

typedef struct {
    char r,g,b;
} rgb;

typedef struct {
   int sx,sy,size,flags;
} gfxmode;

#pragma pack (push);
#pragma pack (1);           // No structure member alignement

// TGA Header

typedef struct {
   char id_length;
   char color_map_type;
   char image_type;
   short first_color_map_entry;
   short color_map_length;
   char color_map_entry_size;
   short image_x_origin;
   short image_y_origin;
   short image_width;
   short image_height;
   char bits_per_pixel;
   char image_descriptor_bits;
} tga_header;

#pragma pack (pop);

//-- Function definitions ---------------------------------------------------

void Init_Gfx(void);
void Clear_GfxBuffer(void);
void Display_Frame(void);
int Set_GfxMode(char mode);
void Decrease_GfxWindowSize(void);
void Increase_GfxWindowSize(void);
int Save_TGA(void);
