#ifndef  _GIFIMAGE_H
#define  _GIFIMAGE_H


#ifndef  _BALDEF_H
#include "BalDef.h"
#endif



class BFile;
class BTexture;



class BGIFImage {
private:
    BBOOL      m_loaded;
    int        m_width;
    int        m_height;
    BBOOL      m_gpalflag;
    int        m_colorbits;
    int        m_gpixbits;
    int        m_backcolor;
    BREAL      m_aspect;
    BBOOL      m_gsorted;
    int        m_palsize;
    BRGB *     m_palette;
    BBOOL      m_interlaced;
    int        m_pixlen;
    int        m_left;
    int        m_top;
    BBOOL      m_lpalflag;
    int        m_lpixbits;

    BBOOL      m_firstpixel;
    int        m_codesize;
    int        m_setcodesize;
    int        m_maxcode;
    int        m_maxcodesize;
    int        m_clearcode;
    int        m_endcode;
    int *      m_table [2];
    int *      m_stack;
    int *      m_stackptr;
    BBYTE      m_buffer [280];
    int        m_curbit;
    int        m_lastbit;
    BBOOL      m_done;
    int        m_lastbyte;
    BBOOL      m_zerodata;
    int        m_prevcode;
    int        m_firstcode;
    

    BTexture * m_texture;    
    
    enum {
        GIF87a,
        GIF89a
    } m_version;


private:
    BBOOL LoadFileHeader (BFile & file);
    BBOOL LoadImageHeader (BFile & file);
    BBOOL LoadPalette (BFile & file);
    BBOOL LoadExtension (BFile & file);
    int   GetCode (BFile & file);
    BBOOL GetPixel (BFile & file, BBYTE & pix); 


public:
    BGIFImage ();
   ~BGIFImage ();

    BBOOL Load (const char * name);

    inline BTexture & GetTexture ()  {return * m_texture;}
    inline BRGB     * GetPalette ()  {return m_palette;}
};



#endif
