/*---------------------------------------------------------------------------
                      THE CHAOS ENGINE - KEYBOARD.C

                    Protected mode keyboard routines.
---------------------------------------------------------------------------*/

#define KEYBOARD

#include <stdio.h>
#include <dos.h>

#include "keyboard.h"

void (__interrupt __far *oldint_09)();

volatile char keys[128];
volatile char hit,code;
char keyboard_installed=FALSE;

// The keyboard interrupt handler.

void __far __interrupt KeyHandler()
{
   code=inp(0x60);
   if (code<128) {
      keys[code]=1;
      hit=1;
   }
   else keys[code-128]=0;

   code=inp(0x61);
   outp(0x61, code | 0x80);
   outp(0x20, 0x20);
}

// Install our new protected mode Keyboard ISR.

void Install_KeyHandler(void)
{
int i;
if (!keyboard_installed) {
   for (i=0; i<128; i++) keys[i]=FALSE;        // Clear keystatus buffer
   oldint_09=_dos_getvect(KEY_INT);
   _dos_setvect(KEY_INT, KeyHandler);
   puts("KeyHandler ISR Installed...");
   keyboard_installed=TRUE; hit=FALSE;
}
}

// Remove Keyboard ISR

void Remove_KeyHandler(void)
{
if (keyboard_installed) {
   _dos_setvect(KEY_INT, oldint_09);
   keyboard_installed=FALSE;
}
}

// Returns TRUE if a key has been hit since last time KeyHit() was called.

char KeyHit(void)
{
if (hit) {
   hit=FALSE;
   return TRUE;
} else return FALSE;
}

// Returns TRUE if key has been hit and waits until it's released.

char TestKey(int key)
{
if (keys[key]) {
   while(keys[key]);
   hit=FALSE;
   return TRUE;
} else return FALSE;
}

