/*---------------------------------------------------------------------------
                       THE CHAOS ENGINE - KEYBOARD.H

---------------------------------------------------------------------------*/

#define Key(x) keys[x]

#ifndef KEYBOARD
   extern volatile char keys[128];
#endif

#ifndef TRUE
   #define TRUE 1
#endif

#ifndef FALSE
   #define FALSE 0
#endif

#define A_KEY 30
#define B_KEY 48
#define C_KEY 46
#define D_KEY 32
#define E_KEY 18
#define F_KEY 33
#define G_KEY 34
#define H_KEY 35
#define I_KEY 23
#define P_KEY 25
#define R_KEY 19
#define T_KEY 20
#define X_KEY 45
#define Y_KEY 21
#define Z_KEY 44
#define M_KEY 50
#define Q_KEY 16

#define UP_KEY 72
#define DOWN_KEY 80
#define LEFT_KEY 75
#define RIGHT_KEY 77

#define HOME_KEY 71
#define END_KEY 79
#define INS_KEY 82
#define DEL_KEY 83
#define PGUP_KEY 73
#define PGDN_KEY 81

#define ESC_KEY 1
#define ENTER_KEY 28

#define PLUS_KEY 78
#define MINUS_KEY 74

#define SPACE_KEY 57
#define CTRL_KEY 29
#define ALT_KEY 56
#define LSHIFT_KEY 42
#define RSHIFT_KEY 54
#define CAPSLOCK_KEY 58
#define TAB_KEY 15

#define F1_KEY 59
#define F2_KEY 60
#define F3_KEY 61
#define F4_KEY 62
#define F5_KEY 63
#define F6_KEY 64
#define F7_KEY 65
#define F8_KEY 66
#define F9_KEY 67
#define F10_KEY 68
#define F11_KEY 87
#define F12_KEY 88

#define KEY_INT 0x9

void Install_KeyHandler(void);
void Remove_KeyHandler(void);
char KeyHit(void);
char TestKey(int key);
