;Ŀ
;               -- Linear Framebuffer Graphics Routines --                  
;                                                                           
;

; QEDIT-COMPILE="c:\c\kod\3d\build.bat"

        .486P
        .MODEL FLAT

        .DATA

        EXTRN _gfxbuffer : DWORD, _gfxbufsize : DWORD, _backfill : DWORD
        EXTRN _edge1 : DWORD, _edge2 : DWORD
        EXTRN _color1 : DWORD, _color2 : DWORD
        EXTRN _ymultab : DWORD, _bytes_per_frame : DWORD
        EXTRN _bottom_clip : DWORD, _right_clip : DWORD
        EXTRN _ysize : DWORD, _xsize : DWORD, _vmemdest : DWORD

        PUBLIC ClearBuffer_, DisplayBuffer_Mode13_
        PUBLIC DrawHLines_S_, DrawHLines_G_

MAXLONG           EQU   07fffffffh

ymax              dd   ?
line_address      dd   ?



        .CODE

; Clear the framebuffer

ClearBuffer_ PROC NEAR
        push   eax
        push   ecx
        push   edi

        mov    edi, [_gfxbuffer]
        mov    ecx, [_bytes_per_frame]
        shr    ecx, 2
        rep    stosd

        pop    edi
        pop    ecx
        pop    eax
        ret
ClearBuffer_ ENDP


; Clear and Copy framebuffer to video memory.

        ALIGN 16

DisplayBuffer_Mode13_ PROC NEAR
        pushad

        mov    esi, [_gfxbuffer]
        mov    edi, 0a0000h
        add    edi, [_vmemdest]
        mov    edx, [_backfill]
        mov    ecx, [_xsize]
        shr    ecx, 2                      ; cl = quads per row
        mov    ebx, [_ysize]               ; ebx = rows to copy
        mov    ebp, 320
        sub    ebp, [_xsize]               ; bytes to add to edi

@YLoop:
        mov    ch, cl
@XLoop:
        mov    eax, [esi]
        mov    [esi], edx
        add    esi, 4
        mov    [edi], eax
        add    edi, 4

        dec    ch
        jnz    @XLoop

        add    edi, ebp

        dec    ebx
        jnz    @YLoop

        popad
        ret
DisplayBuffer_Mode13_ ENDP


        ALIGN 16

; Draw solid colored lines

DrawHLines_S_ PROC NEAR
        pushad
        mov    [ymax], ebx                 ; yend
        mov    esi, edx                    ; ystart
        mov    ebp, _ymultab[esi*4]        ; get startline offset
        add    ebp, [_gfxbuffer]

        mov    ah, al
        mov    dx, ax
        shl    edx, 16
        mov    dx, ax
@HLineLoop:
        mov    eax, _edge1[esi*4]
        cmp    eax, MAXLONG
        je     @No_Line
        sar    eax, 10
        mov    ebx, _edge2[esi*4]
        sar    ebx, 10

        cmp    eax, ebx
        jle    @Right_Order
        xchg   eax, ebx
@Right_Order:
 
        cmp    eax, 0                 ; Behver linjen klippas?
        jge    @Not_Left_Clipped
        mov    eax, 0                  ; Ja, klipp den
        cmp    ebx, 0
        jl     @Get_Out
@Not_Left_Clipped:
        cmp    ebx, [_right_clip]
        jle    @Not_Right_Clipped
        mov    ebx, [_right_clip]
        cmp    eax, [_right_clip]
        jg     @Get_Out
@Not_Right_Clipped:
        mov    edi, ebp
        add    edi, eax
        mov    ecx, ebx

        sub    ecx, eax
        inc    ecx
        mov    eax, edx
        mov    ebx, 2

        test   edi, 1
        jz     @Even1
        mov    [edi], al
        inc    edi
        dec    ecx
        jz     @Get_Out
@Even1:
        test   edi, ebx
        jz     @Even2
        mov    [edi], ax
        add    edi, ebx
        sub    ecx, ebx
        jle    @Get_Out
@Even2:
        mov    ebx, ecx
        shr    ecx, 2
        rep    stosd
        jnc    @Not2
        mov    [edi], ax
        add    edi, 2
@Not2:
        test   ebx, 1
        jz     @Not1
        mov    [edi], al
@Not1:

@Get_Out:
        mov    _edge1[esi*4], MAXLONG
@No_Line:
        add    ebp, [_xsize]
        inc    esi
        cmp    esi, [ymax]
        jne    @HLineLoop
        popad
        ret

DrawHLines_S_ ENDP


        ALIGN 16
; Draw Gouraud-shaded lines

DrawHLines_G_ PROC NEAR
        pushad
        mov    [ymax], edx
        mov    esi, eax
        mov    ebp, _ymultab[eax*4]        ; get startline offset
        add    ebp, [_gfxbuffer]
        mov    [line_address], ebp

@HLineLoopG:
        mov    ecx, _edge1[esi*4]
        sar    ecx, 8
        mov    ebx, _color1[esi*4]
        mov    edx, _edge2[esi*4]
        sar    edx, 8
        mov    eax, _color2[esi*4]

        cmp    ecx, edx
        jle    @Right_OrderG
        xchg   eax, ebx
        xchg   ecx, edx
@Right_OrderG:
        cmp    ecx, 0                ; Behver linjen klippas?
        jl     @Left_ClippedG
@LClipDone:
        cmp    edx, [_right_clip]
        jg     @Right_ClippedG
@RClipDone:

        mov    edi, [line_address]
        mov    ebp, edx                         ; ebp = end of line
        sub    eax, ebx
        sub    ebp, ecx                         ; Get length of line
        inc    ebp
        cwd
        idiv   bp                               ; eax = (c2-c1) / length
        cwde

        dec    ecx

        add    edi, ecx
@GouraudLoop:
        inc    edi
        add    ebx, eax
        dec    ebp
        mov    [edi], bh
        jnz    @GouraudLoop

@Get_OutG:
        mov    eax, [_xsize]
        add    [line_address], eax
        mov    _edge1[esi*4], MAXLONG
        inc    esi
        cmp    esi, [ymax]
        jne    @HLineLoopG
        popad
        ret


@Right_ClippedG:
        mov    edx, [_right_clip]
        cmp    ecx, edx
        jg     @Get_OutG
        jmp    @RClipDone
@Left_ClippedG:
        mov    ecx, 0                 ; Ja, klipp den
        cmp    edx, ecx
        jl     @Get_OutG
        jmp    @LClipDone

DrawHLines_G_ ENDP


END


