#include "Copyright.h"
#include "Lift.h"
#include "Line.h"





BLift::BLift (int index, int linecount, 
              int rate,
              BREAL ceillevel,
              BREAL minfloor, BREAL maxfloor) :

    BVariable  (),
    BSector    (index, linecount),
    m_rate     (rate),
    m_minfloor (minfloor),
    m_maxfloor (maxfloor)  {
    
    m_ceillevel = ceillevel;
    return;
}
    



BLift::~BLift ()   {}





void BLift::OnTimer (int) {
    static BBOOL up   = BTRUE;
    static int   step = 0;

    BASSERT (m_rate > 0);

    BREAL startlevel  = up ? m_minfloor  : m_maxfloor;
    BREAL endlevel    = up ? m_maxfloor  : m_minfloor;
    BREAL delta       = (endlevel-startlevel)  * (BREAL)step / (BREAL)m_rate;

    m_floorlevel  = startlevel +  delta;
    BASSERT (m_floorlevel >= m_minfloor && m_floorlevel <= m_maxfloor);
    

    for (int i=0; i<m_linecount; i++) {
        BFACE face;
        if (m_lineset[i]->m_face[BFRONT].m_sector == this)
            face = BBACK;
        else
            face = BFRONT;
        if (m_lineset[i]->m_face[face].m_sector != BNULL)
            m_lineset[i]->m_face[face].m_yshift = m_maxfloor - m_minfloor - m_floorlevel;
        }


    if (++step > m_rate) {
        up = ! up;
        step = 0;
        }
}
