#include "Copyright.h"
#include "Line.h"
#include "Vector.h"
#include "Point.h"
#include "Sector.h"





BLine::BLine (int index, const BPoint * start, const BPoint * end) :
    m_timestamp (0),
    m_index     (index),
    m_start     (start),
    m_end       (end),
    m_vector    (*end - *start)    {
    
    m_face[BFRONT].m_sector = BNULL;
    m_face[BFRONT].m_utext  = BNULL;
    m_face[BFRONT].m_mtext  = BNULL;
    m_face[BFRONT].m_ltext  = BNULL;
    m_face[BFRONT].m_xshift = 0.0f;
    m_face[BFRONT].m_yshift = 0.0f;
    m_face[BBACK ].m_sector = BNULL;
    m_face[BBACK ].m_utext  = BNULL;
    m_face[BBACK ].m_mtext  = BNULL;
    m_face[BBACK ].m_ltext  = BNULL;
    m_face[BBACK ].m_xshift = 0.0f;
    m_face[BBACK ].m_yshift = 0.0f;
}







const BSector * BLine::ThruTest (BFACE face, 
                                 BREAL & top, BREAL & bottom) const {

    BASSERT (face == BFRONT || face == BBACK);
    

    const BSector * next   = m_face[BOTHER (face)].m_sector;
    const BSector * sector = m_face[face].m_sector;
    top    = sector->m_ceillevel;
    bottom = sector->m_floorlevel;


    if (next != BNULL) {
        if (next->m_ceillevel < sector->m_ceillevel)
            top = BMAX (next->m_ceillevel, sector->m_floorlevel);
        if (next->m_floorlevel > sector->m_floorlevel)
            bottom = BMIN (next->m_floorlevel, sector->m_ceillevel);
        }
    
    return next;
}





