#include "Copyright.h"
#include "Map.h"
#include "Point.h"
#include "Line.h"
#include "Sector.h"
#include "Texture.h"
#include "Lift.h"






BMap::BMap () {
    
    extern void BalPalette (BRGB * pal);

    int i, j;

    m_textcount  = 8;
    m_pointcount = 49;
    m_linecount  = 59;
    m_seccount   = 11;

    m_textset  = new BTexture * [m_textcount];
    m_pointset = new BPoint   * [m_pointcount];
    m_lineset  = new BLine    * [m_linecount];
    m_secset   = new BSector  * [m_seccount];

    
    m_textset[0] = new BTexture ("rustic.bif");
    m_textset[1] = new BTexture ("inlay.bif");
    m_textset[2] = new BTexture ("redbrick.bif");
    m_textset[3] = new BTexture ("rock.bif");
    m_textset[4] = new BTexture ("cobble.bif");
    m_textset[5] = new BTexture ("bricktile.bif");
    m_textset[6] = new BTexture ("marble.bif");
    m_textset[7] = new BTexture ("sky.bif");


    for (i=0; i<m_pointcount; i++) {
        const static struct {BREAL x; BREAL y;} pdata [49] = {
            { 0.0f,  0.0f},     // 0
            {100.f,  0.0f},     // 1
            {100.f, 80.0f},     // 2
            {10.0f, 80.0f},     // 3
            { 0.0f, 80.0f},     // 4
            { 0.0f, 60.0f},     // 5
            { 0.0f, 55.0f},     // 6
            { 0.0f, 50.0f},     // 7
            { 0.0f, 45.0f},     // 8
            { 0.0f, 40.0f},     // 9
            { 0.0f, 35.0f},     // 10
            { 0.0f, 30.0f},     // 11
            { 0.0f, 25.0f},     // 12
            { 0.0f, 20.0f},     // 13
            {10.0f, 60.0f},     // 14
            {10.0f, 55.0f},     // 15
            {10.0f, 50.0f},     // 16
            {10.0f, 45.0f},     // 17
            {10.0f, 40.0f},     // 18
            {10.0f, 35.0f},     // 19
            {10.0f, 30.0f},     // 20
            {10.0f, 25.0f},     // 21
            {10.0f, 20.0f},     // 22
            {30.0f, 20.0f},     // 23
            {30.0f, 60.0f},     // 24

            {50.0f, 30.0f},     // 25
            {50.0f, 20.0f},     // 26
            {60.0f, 20.0f},     // 27
            {60.0f, 30.0f},     // 28

            {50.0f, 50.0f},     // 29
            {50.0f, 40.0f},     // 30
            {60.0f, 40.0f},     // 31
            {60.0f, 50.0f},     // 32

            {50.0f, 70.0f},     // 33
            {50.0f, 60.0f},     // 34
            {60.0f, 60.0f},     // 35
            {60.0f, 70.0f},     // 36

            {70.0f, 30.0f},     // 37
            {70.0f, 20.0f},     // 38
            {80.0f, 20.0f},     // 39
            {80.0f, 30.0f},     // 40

            {70.0f, 50.0f},     // 41
            {70.0f, 40.0f},     // 42
            {80.0f, 40.0f},     // 43
            {80.0f, 50.0f},     // 44

            {70.0f, 70.0f},     // 45
            {70.0f, 60.0f},     // 46
            {80.0f, 60.0f},     // 47
            {80.0f, 70.0f}};    // 48



        m_pointset[i] = new BPoint (pdata[i].x, pdata[i].y);
        }


    for (i=0; i<m_linecount; i++) {
        const static struct {
            int start;
            int end;
            int futext;
            int fmtext;
            int fltext;
        } ldata [59] = {
            { 1, 0,  BVOID,     0, BVOID},     // 0 
            { 2, 1,  BVOID,     0, BVOID},     // 1 
            { 3, 2,  BVOID,     0, BVOID},     // 2 
            { 4, 3,  BVOID,     0, BVOID},     // 3 
            { 5, 4,  BVOID,     2, BVOID},     // 4 
            { 6, 5,  BVOID,     2, BVOID},     // 5 
            { 7, 6,  BVOID,     2, BVOID},     // 6 
            { 8, 7,  BVOID,     2, BVOID},     // 7 
            { 9, 8,  BVOID,     2, BVOID},     // 8 
            {10, 9,  BVOID,     2, BVOID},     // 9 
            {11,10,  BVOID,     2, BVOID},     // 10
            {12,11,  BVOID,     2, BVOID},     // 11
            {13,12,  BVOID,     2, BVOID},     // 12
            {14,15,  BVOID, BVOID,     1},     // 13
            {15,16,  BVOID, BVOID,     1},     // 14
            {16,17,  BVOID, BVOID,     1},     // 15
            {17,18,  BVOID, BVOID,     1},     // 16
            {18,19,  BVOID, BVOID,     1},     // 17
            {19,20,  BVOID, BVOID,     1},     // 18
            {20,21,  BVOID, BVOID,     1},     // 19
            {21,22,  BVOID, BVOID,     1},     // 20
            {22,23,  BVOID, BVOID,     1},     // 21
            {23,24,  BVOID, BVOID,     1},     // 22
            {24,14,  BVOID, BVOID,     1},     // 23
            {25,26,  BVOID,     5, BVOID},     // 24
            {26,27,  BVOID,     5, BVOID},     // 25
            {27,28,  BVOID,     5, BVOID},     // 26
            {13,22,  BVOID, BVOID,     3},     // 27
            {12,21,  BVOID, BVOID,     3},     // 28
            {11,20,  BVOID, BVOID,     3},     // 29
            {10,19,  BVOID, BVOID,     3},     // 30
            { 9,18,  BVOID, BVOID,     3},     // 31
            { 8,17,  BVOID, BVOID,     3},     // 32
            { 7,16,  BVOID, BVOID,     3},     // 33
            { 6,15,  BVOID, BVOID,     3},     // 34
            { 5,14,  BVOID, BVOID,     1},     // 35
            {14, 3,  BVOID, BVOID,     1},     // 36
            { 0,13,  BVOID,     2, BVOID},     // 37
            {28,25,  BVOID,     5, BVOID},     // 38
            {29,30,  BVOID,     5, BVOID},     // 39
            {30,31,  BVOID,     5, BVOID},     // 40
            {31,32,  BVOID,     5, BVOID},     // 41
            {32,29,  BVOID,     5, BVOID},     // 42
            {33,34,  BVOID,     5, BVOID},     // 43
            {34,35,  BVOID,     5, BVOID},     // 44
            {35,36,  BVOID,     5, BVOID},     // 45
            {36,33,  BVOID,     5, BVOID},     // 46
            {37,38,  BVOID,     5, BVOID},     // 47
            {38,39,  BVOID,     5, BVOID},     // 48
            {39,40,  BVOID,     5, BVOID},     // 49
            {40,37,  BVOID,     5, BVOID},     // 50
            {41,42,  BVOID,     5, BVOID},     // 51
            {42,43,  BVOID,     5, BVOID},     // 52
            {43,44,  BVOID,     5, BVOID},     // 53
            {44,41,  BVOID,     5, BVOID},     // 54
            {45,46,  BVOID,     5, BVOID},     // 55
            {46,47,  BVOID,     5, BVOID},     // 56
            {47,48,  BVOID,     5, BVOID},     // 57
            {48,45,  BVOID,     5, BVOID}};    // 58
        
        
        m_lineset[i] = new BLine (i, m_pointset[ldata[i].start],
                                     m_pointset[ldata[i].end]);
        m_lineset[i]->m_face[BFRONT].m_utext  = (ldata[i].futext==BVOID) ? BNULL : m_textset[ldata[i].futext];
        m_lineset[i]->m_face[BFRONT].m_mtext  = (ldata[i].fmtext==BVOID) ? BNULL : m_textset[ldata[i].fmtext];
        m_lineset[i]->m_face[BFRONT].m_ltext  = (ldata[i].fltext==BVOID) ? BNULL : m_textset[ldata[i].fltext];
        m_lineset[i]->m_face[BFRONT].m_sector = BNULL;
        m_lineset[i]->m_face[BBACK ].m_utext  = BNULL;
        m_lineset[i]->m_face[BBACK ].m_mtext  = BNULL;
        m_lineset[i]->m_face[BBACK ].m_ltext  = BNULL;
        m_lineset[i]->m_face[BBACK ].m_sector = BNULL;
        }


    m_lineset[35]->m_face[BBACK].m_ltext = m_textset[2];

    m_lineset[13]->m_face[BBACK].m_utext = m_textset[3];
    m_lineset[14]->m_face[BBACK].m_utext = m_textset[3];
    m_lineset[15]->m_face[BBACK].m_utext = m_textset[3];
    m_lineset[16]->m_face[BBACK].m_utext = m_textset[3];
    m_lineset[17]->m_face[BBACK].m_utext = m_textset[3];
    m_lineset[18]->m_face[BBACK].m_utext = m_textset[3];
    m_lineset[19]->m_face[BBACK].m_utext = m_textset[3];
    m_lineset[20]->m_face[BBACK].m_utext = m_textset[3];
    m_lineset[21]->m_face[BBACK].m_utext = m_textset[3];
    m_lineset[22]->m_face[BBACK].m_utext = m_textset[3];
    m_lineset[23]->m_face[BBACK].m_utext = m_textset[3];

    m_lineset[37]->m_face[BFRONT].m_xshift =  0.0f;
    m_lineset[12]->m_face[BFRONT].m_xshift = 20.0f;
    m_lineset[11]->m_face[BFRONT].m_xshift = 25.0f;
    m_lineset[10]->m_face[BFRONT].m_xshift = 30.0f;
    m_lineset[ 9]->m_face[BFRONT].m_xshift = 35.0f;
    m_lineset[ 8]->m_face[BFRONT].m_xshift = 40.0f;
    m_lineset[ 7]->m_face[BFRONT].m_xshift = 45.0f;
    m_lineset[ 6]->m_face[BFRONT].m_xshift = 50.0f;
    m_lineset[ 5]->m_face[BFRONT].m_xshift = 55.0f;
    m_lineset[ 4]->m_face[BFRONT].m_xshift = 60.0f;



    m_secset[0] = new BSector (0, 33);
    m_secset[0]->m_ceillevel  = 30.0f;
    m_secset[0]->m_floorlevel =  0.0f;
    m_secset[0]->m_ceiltext   = m_textset[6];
    m_secset[0]->m_floortext  = m_textset[4];
    m_secset[0]->Line ( 0) = m_lineset[0];
    m_secset[0]->Line ( 1) = m_lineset[1];
    m_secset[0]->Line ( 2) = m_lineset[2];
    m_secset[0]->Line ( 3) = m_lineset[26];
    m_secset[0]->Line ( 4) = m_lineset[36];
    m_secset[0]->Line ( 5) = m_lineset[23];
    m_secset[0]->Line ( 6) = m_lineset[22];
    m_secset[0]->Line ( 7) = m_lineset[21];
    m_secset[0]->Line ( 8) = m_lineset[27];
    m_secset[0]->Line ( 9) = m_lineset[37];
    m_secset[0]->Line (10) = m_lineset[24];
    m_secset[0]->Line (11) = m_lineset[25];
    m_secset[0]->Line (12) = m_lineset[38];
    m_secset[0]->Line (13) = m_lineset[39];
    m_secset[0]->Line (14) = m_lineset[40];
    m_secset[0]->Line (15) = m_lineset[41];
    m_secset[0]->Line (16) = m_lineset[42];
    m_secset[0]->Line (17) = m_lineset[43];
    m_secset[0]->Line (18) = m_lineset[44];
    m_secset[0]->Line (19) = m_lineset[45];
    m_secset[0]->Line (20) = m_lineset[46];
    m_secset[0]->Line (21) = m_lineset[47];
    m_secset[0]->Line (22) = m_lineset[48];
    m_secset[0]->Line (23) = m_lineset[49];
    m_secset[0]->Line (24) = m_lineset[50];
    m_secset[0]->Line (25) = m_lineset[51];
    m_secset[0]->Line (26) = m_lineset[52];
    m_secset[0]->Line (27) = m_lineset[53];
    m_secset[0]->Line (28) = m_lineset[54];
    m_secset[0]->Line (29) = m_lineset[55];
    m_secset[0]->Line (30) = m_lineset[56];
    m_secset[0]->Line (31) = m_lineset[57];
    m_secset[0]->Line (32) = m_lineset[58];
    
    m_lineset[ 0]->m_face[BFRONT].m_sector = m_secset[0];
    m_lineset[ 1]->m_face[BFRONT].m_sector = m_secset[0];
    m_lineset[ 2]->m_face[BFRONT].m_sector = m_secset[0];
    m_lineset[26]->m_face[BFRONT].m_sector = m_secset[0];
    m_lineset[36]->m_face[BFRONT].m_sector = m_secset[0];
    m_lineset[23]->m_face[BFRONT].m_sector = m_secset[0];
    m_lineset[22]->m_face[BFRONT].m_sector = m_secset[0];
    m_lineset[21]->m_face[BFRONT].m_sector = m_secset[0];
    m_lineset[27]->m_face[BFRONT].m_sector = m_secset[0];
    m_lineset[37]->m_face[BFRONT].m_sector = m_secset[0];
    m_lineset[24]->m_face[BFRONT].m_sector = m_secset[0];
    m_lineset[25]->m_face[BFRONT].m_sector = m_secset[0];
    m_lineset[38]->m_face[BFRONT].m_sector = m_secset[0];
    m_lineset[39]->m_face[BFRONT].m_sector = m_secset[0];
    m_lineset[40]->m_face[BFRONT].m_sector = m_secset[0];
    m_lineset[41]->m_face[BFRONT].m_sector = m_secset[0];
    m_lineset[42]->m_face[BFRONT].m_sector = m_secset[0];
    m_lineset[43]->m_face[BFRONT].m_sector = m_secset[0];
    m_lineset[44]->m_face[BFRONT].m_sector = m_secset[0];
    m_lineset[45]->m_face[BFRONT].m_sector = m_secset[0];
    m_lineset[46]->m_face[BFRONT].m_sector = m_secset[0];
    m_lineset[47]->m_face[BFRONT].m_sector = m_secset[0];
    m_lineset[48]->m_face[BFRONT].m_sector = m_secset[0];
    m_lineset[49]->m_face[BFRONT].m_sector = m_secset[0];
    m_lineset[50]->m_face[BFRONT].m_sector = m_secset[0];
    m_lineset[51]->m_face[BFRONT].m_sector = m_secset[0];
    m_lineset[52]->m_face[BFRONT].m_sector = m_secset[0];
    m_lineset[53]->m_face[BFRONT].m_sector = m_secset[0];
    m_lineset[54]->m_face[BFRONT].m_sector = m_secset[0];
    m_lineset[55]->m_face[BFRONT].m_sector = m_secset[0];
    m_lineset[56]->m_face[BFRONT].m_sector = m_secset[0];
    m_lineset[57]->m_face[BFRONT].m_sector = m_secset[0];
    m_lineset[58]->m_face[BFRONT].m_sector = m_secset[0];


    BLift * lift = new BLift (1, 4, 20, 30.0f, 0.0f, 20.0f);
    lift->Register ();
    m_secset[1] = lift;
    m_secset[1]->m_ceiltext   = m_textset[6];
    m_secset[1]->m_floortext  = m_textset[1];
    m_secset[1]->Line ( 0) = m_lineset[3];
    m_secset[1]->Line ( 1) = m_lineset[4];
    m_secset[1]->Line ( 2) = m_lineset[35];
    m_secset[1]->Line ( 3) = m_lineset[36];
    m_lineset[ 3]->m_face[BFRONT].m_sector = m_secset[1];
    m_lineset[ 4]->m_face[BFRONT].m_sector = m_secset[1];
    m_lineset[35]->m_face[BBACK ].m_sector  = m_secset[1];
    m_lineset[36]->m_face[BBACK ].m_sector  = m_secset[1];
    


    m_secset[2] = new BSector (2, 4);
    m_secset[2]->m_ceillevel  = 30.0f;
    m_secset[2]->m_floorlevel =  2.0f;
    m_secset[2]->m_ceiltext   = m_textset[6];
    m_secset[2]->m_floortext  = m_textset[3];
    m_secset[2]->Line ( 0) = m_lineset[12];
    m_secset[2]->Line ( 1) = m_lineset[28];
    m_secset[2]->Line ( 2) = m_lineset[20];
    m_secset[2]->Line ( 3) = m_lineset[27];
    m_lineset[12]->m_face[BFRONT].m_sector = m_secset[2];
    m_lineset[28]->m_face[BFRONT].m_sector = m_secset[2];
    m_lineset[20]->m_face[BFRONT].m_sector = m_secset[2];
    m_lineset[27]->m_face[BBACK ].m_sector  = m_secset[2];


    m_secset[3] = new BSector (3, 4);
    m_secset[3]->m_ceillevel  = 30.0f;
    m_secset[3]->m_floorlevel =  4.0f;
    m_secset[3]->m_ceiltext   = m_textset[6];
    m_secset[3]->m_floortext  = m_textset[3];
    m_secset[3]->Line ( 0) = m_lineset[11];
    m_secset[3]->Line ( 1) = m_lineset[29];
    m_secset[3]->Line ( 2) = m_lineset[19];
    m_secset[3]->Line ( 3) = m_lineset[28];
    m_lineset[11]->m_face[BFRONT].m_sector = m_secset[3];
    m_lineset[29]->m_face[BFRONT].m_sector = m_secset[3];
    m_lineset[19]->m_face[BFRONT].m_sector = m_secset[3];
    m_lineset[28]->m_face[BBACK ].m_sector  = m_secset[3];


    m_secset[4] = new BSector (4, 4);
    m_secset[4]->m_ceillevel  = 30.0f;
    m_secset[4]->m_floorlevel =  6.0f;
    m_secset[4]->m_ceiltext   = m_textset[6];
    m_secset[4]->m_floortext  = m_textset[3];
    m_secset[4]->Line ( 0) = m_lineset[10];
    m_secset[4]->Line ( 1) = m_lineset[30];
    m_secset[4]->Line ( 2) = m_lineset[18];
    m_secset[4]->Line ( 3) = m_lineset[29];
    m_lineset[10]->m_face[BFRONT].m_sector = m_secset[4];
    m_lineset[30]->m_face[BFRONT].m_sector = m_secset[4];
    m_lineset[18]->m_face[BFRONT].m_sector = m_secset[4];
    m_lineset[29]->m_face[BBACK ].m_sector  = m_secset[4];


    m_secset[5] = new BSector (5, 4);
    m_secset[5]->m_ceillevel  = 30.0f;
    m_secset[5]->m_floorlevel =  8.0f;
    m_secset[5]->m_ceiltext   = m_textset[6];
    m_secset[5]->m_floortext  = m_textset[3];
    m_secset[5]->Line ( 0) = m_lineset[ 9];
    m_secset[5]->Line ( 1) = m_lineset[31];
    m_secset[5]->Line ( 2) = m_lineset[17];
    m_secset[5]->Line ( 3) = m_lineset[30];
    m_lineset[ 9]->m_face[BFRONT].m_sector = m_secset[5];
    m_lineset[31]->m_face[BFRONT].m_sector = m_secset[5];
    m_lineset[17]->m_face[BFRONT].m_sector = m_secset[5];
    m_lineset[30]->m_face[BBACK ].m_sector  = m_secset[5];


    m_secset[6] = new BSector (6, 4);
    m_secset[6]->m_ceillevel  = 30.0f;
    m_secset[6]->m_floorlevel = 10.0f;
    m_secset[6]->m_ceiltext   = m_textset[6];
    m_secset[6]->m_floortext  = m_textset[3];
    m_secset[6]->Line ( 0) = m_lineset[ 8];
    m_secset[6]->Line ( 1) = m_lineset[32];
    m_secset[6]->Line ( 2) = m_lineset[16];
    m_secset[6]->Line ( 3) = m_lineset[31];
    m_lineset[ 8]->m_face[BFRONT].m_sector = m_secset[6];
    m_lineset[32]->m_face[BFRONT].m_sector = m_secset[6];
    m_lineset[16]->m_face[BFRONT].m_sector = m_secset[6];
    m_lineset[31]->m_face[BBACK ].m_sector  = m_secset[6];


    m_secset[7] = new BSector (7, 4);
    m_secset[7]->m_ceillevel  = 30.0f;
    m_secset[7]->m_floorlevel = 12.0f;
    m_secset[7]->m_ceiltext   = m_textset[6];
    m_secset[7]->m_floortext  = m_textset[3];
    m_secset[7]->Line ( 0) = m_lineset[ 7];
    m_secset[7]->Line ( 1) = m_lineset[33];
    m_secset[7]->Line ( 2) = m_lineset[15];
    m_secset[7]->Line ( 3) = m_lineset[32];
    m_lineset[ 7]->m_face[BFRONT].m_sector = m_secset[7];
    m_lineset[33]->m_face[BFRONT].m_sector = m_secset[7];
    m_lineset[15]->m_face[BFRONT].m_sector = m_secset[7];
    m_lineset[32]->m_face[BBACK ].m_sector  = m_secset[7];


    m_secset[8] = new BSector (8, 4);
    m_secset[8]->m_ceillevel  = 30.0f;
    m_secset[8]->m_floorlevel = 14.0f;
    m_secset[8]->m_ceiltext   = m_textset[6];
    m_secset[8]->m_floortext  = m_textset[3];
    m_secset[8]->Line ( 0) = m_lineset[ 6];
    m_secset[8]->Line ( 1) = m_lineset[34];
    m_secset[8]->Line ( 2) = m_lineset[14];
    m_secset[8]->Line ( 3) = m_lineset[33];
    m_lineset[ 6]->m_face[BFRONT].m_sector = m_secset[8];
    m_lineset[34]->m_face[BFRONT].m_sector = m_secset[8];
    m_lineset[14]->m_face[BFRONT].m_sector = m_secset[8];
    m_lineset[33]->m_face[BBACK ].m_sector  = m_secset[8];


    m_secset[9] = new BSector (9, 4);
    m_secset[9]->m_ceillevel  = 30.0f;
    m_secset[9]->m_floorlevel = 16.0f;
    m_secset[9]->m_ceiltext   = m_textset[6];
    m_secset[9]->m_floortext  = m_textset[3];
    m_secset[9]->Line ( 0) = m_lineset[ 5];
    m_secset[9]->Line ( 1) = m_lineset[35];
    m_secset[9]->Line ( 2) = m_lineset[13];
    m_secset[9]->Line ( 3) = m_lineset[34];
    m_lineset[ 5]->m_face[BFRONT].m_sector = m_secset[9];
    m_lineset[35]->m_face[BFRONT].m_sector = m_secset[9];
    m_lineset[13]->m_face[BFRONT].m_sector = m_secset[9];
    m_lineset[34]->m_face[BBACK ].m_sector  = m_secset[9];


    m_secset[10] = new BSector (10, 11);
    m_secset[10]->m_ceillevel  = 35.0f;
    m_secset[10]->m_floorlevel = 16.0f;
    m_secset[10]->m_ceiltext   = m_textset[7];
    m_secset[10]->m_floortext  = m_textset[1];
    m_secset[10]->m_cxshift    = -10.0f;
    m_secset[10]->m_cyshift    = -20.0f;
    m_secset[10]->Line ( 0) = m_lineset[13];
    m_secset[10]->Line ( 1) = m_lineset[14];
    m_secset[10]->Line ( 2) = m_lineset[15];
    m_secset[10]->Line ( 3) = m_lineset[16];
    m_secset[10]->Line ( 4) = m_lineset[17];
    m_secset[10]->Line ( 5) = m_lineset[18];
    m_secset[10]->Line ( 6) = m_lineset[19];
    m_secset[10]->Line ( 7) = m_lineset[20];
    m_secset[10]->Line ( 8) = m_lineset[21];
    m_secset[10]->Line ( 9) = m_lineset[22];
    m_secset[10]->Line (10) = m_lineset[23];
    m_lineset[13]->m_face[BBACK].m_sector = m_secset[10];
    m_lineset[14]->m_face[BBACK].m_sector = m_secset[10];
    m_lineset[15]->m_face[BBACK].m_sector = m_secset[10];
    m_lineset[16]->m_face[BBACK].m_sector = m_secset[10];
    m_lineset[17]->m_face[BBACK].m_sector = m_secset[10];
    m_lineset[18]->m_face[BBACK].m_sector = m_secset[10];
    m_lineset[19]->m_face[BBACK].m_sector = m_secset[10];
    m_lineset[20]->m_face[BBACK].m_sector = m_secset[10];
    m_lineset[21]->m_face[BBACK].m_sector = m_secset[10];
    m_lineset[22]->m_face[BBACK].m_sector = m_secset[10];
    m_lineset[23]->m_face[BBACK].m_sector = m_secset[10];



    for (i=0; i<m_seccount; i++)
        for (j=0; j<m_secset[i]->m_linecount; j++) {
            const BLine * line = m_secset[i]->m_lineset[j];
            if (line->m_face[BFRONT].m_sector == m_secset[i])
                m_secset[i]->Face (j) = BFRONT;
            else
                m_secset[i]->Face (j) = BBACK;
            }
}





BMap::~BMap () {
    int i;

    for (i=0; i<m_seccount; i++)
        delete m_secset[i];
    for (i=0; i<m_linecount; i++)
        delete m_lineset[i];
    for (i=0; i<m_pointcount; i++)
        delete m_pointset[i];
    for (i=0; i<m_textcount; i++)
        delete m_textset[i];

    delete [] m_secset;
    delete [] m_lineset;
    delete [] m_pointset;
    delete [] m_textset;
}





void BMap::Test (int param) {
    m_secset[0]->m_ceillevel = 70.0f - (BREAL)param*100.0f/200.0f;
    m_secset[0]->m_floorlevel = m_secset[0]->m_ceillevel-40.0f;
}




