Unit Objects;            {3D objects for the ALPHA engine}
                         { THE PHANTOM! oct 26,1996, 27 days to go.}
INTERFACE

uses alpha2,graphics,struct;

const ROTMUL   = 1024;
      SEGMENTS = 18;
      TORUS    = 8;
      STEPSIZE = 2880 div SEGMENTS;
      TORSIZE  = 2880 div TORUS;
      THICK    = 30;

procedure Polygon(s: string);
procedure ZPlane(x1,y1,x2,y2,z1,tp,cl: longint);
procedure XPlane(z1,y1,z2,y2,x1,tp,cl: longint);
procedure YPlane(x1,z1,x2,z2,y1,tp,cl: longint);
function  Bar3D(x1,y1,z1,w,h,d: longint; tp: longint; cl: byte): word;
procedure CreatePul(t: Longint);
procedure CreateTorus(t: Longint; b: boolean; size,sizi: integer; cl: longint);
procedure MirrorCube(x1,y1,z1,h,w,d,tp: longint; cl: word);
procedure ReadGEM(s: string; type_poly:longint; sz: single);
procedure ReadPLG(s: string; tp: longint; sz: single);
procedure ReadASC(s: string; tp: longint; sz: single);
procedure Read3DS( s: string; type_poly: longint; sz: single );
procedure DefineWorld;
procedure Stairs(ox,oy,oz,r1,r2: single; nm,dr,tp,cl: longint);


IMPLEMENTATION


{  _______________________________________________________________________
  /                                                                      /
 / Stairs: Create some cool stairs                                      /
/______________________________________________________________________/ }

procedure Stairs(ox,oy,oz,r1,r2: single; nm,dr,tp,cl: longint);
var x1,y1,x2,y2,x3,y3,x4,y4: single;
    i,a,b,c,d,step: longint;
begin
   step:=2880 div nm;
   for i:=1 to nm do begin
      x1:=r1*_sn[i*step];
      y1:=r1*_cs[i*step];
      x2:=r1*_sn[(i+1)*step];
      y2:=r1*_cs[(i+1)*step];
      x4:=r2*_sn[(i+1)*step];
      y4:=r2*_cs[(i+1)*step];
      x3:=r2*_sn[i*step];
      y3:=r2*_cs[i*step];
      a:=_Coords;
      x1:=0;
      y1:=0;
      x2:=100;
      y2:=0;
      x3:=100;
      y3:=100;
      x4:=0;
      y4:=100;
      a:=FindCoord(ox+x1,oy+i*dr,oz+y1);
      b:=FindCoord(ox+x2,oy+i*dr,oz+y2);
      c:=FindCoord(ox+x3,oy+i*dr,oz+y3);
      d:=FindCoord(ox+x4,oy+i*dr,oz+y4);
      CreatePolygon(a,b,c,d,GouradTx,7);
      DoubleSided(_Polies);
   end;
end;


{  _______________________________________________________________________
  /                                                                      /
 / DefineWorld: Old Sample World                                        /
/______________________________________________________________________/ }

procedure DefineWorld;
begin
   {-------------STARTING ROOM------------}
   Sector(1);
   {Wall}
   ZPlane(-300,-80,-100,40,-300,GouradTx,1);
   ZPlane(-100,-80,100,40,-300,GouradTx,1);
   ZPlane(100,-80,300,40,-300,GouradTx,1);
   XPlane(-300,-80,-100,40,300,GouradTx,1);
   XPlane(-100,-80,100,40,300,GouradTx,1);
   XPlane(100,-80,300,40,300,GouradTx,1);
   XPlane(-300,-80,-100,40,-300,GouradTx,1);
   XPlane(100,-80,300,40,-300,GouradTx,1);
   {Wooden floor}
   YPlane(-300,-300,-100,-100,40,GouradTx,10);
   YPlane(-100,-300,100,-100,40,GouradTx,10);
   YPlane(100,-300,300,-100,40,GouradTx,10);
   {Bridge}
   Bar3D(-180,30,-125,50,10,250,GouradTx,6);
   {Underwater stuff}
   YPlane(-300,-100,-100,100,100,GouradTx,7);
   YPlane(-100,-100,100,100,100,GouradTx,7);
   YPlane(100,-100,300,100,100,GouradTx,7);
   ZPlane(-300,60,-100,100,-100,GouradTx,7);
   ZPlane(-100,60,100,100,-100,GouradTx,7);
   ZPlane(100,60,300,100,-100,GouradTx,7);
   ZPlane(-300,60,-100,100,100,GouradTx,7);
   ZPlane(-100,60,100,100,100,GouradTx,7);
   ZPlane(100,60,300,100,100,GouradTx,7);
   XPlane(-100,60,100,100,-300,GouradTx,7);
   XPlane(-100,60,100,100,300,GouradTx,7);
   {Stones for water}
   ZPlane(-300,60,-100,40,-100,GouradTx,7);
   ZPlane(-100,60,100,40,-100,GouradTx,7);
   ZPlane(100,60,300,40,-100,GouradTx,7);
   ZPlane(-300,60,-100,40,100,GouradTx,7);
   ZPlane(-100,60,100,40,100,GouradTx,7);
   ZPlane(100,60,300,40,100,GouradTx,7);
   {Wooden floor}
   YPlane(-300,100,-100,300,40,GouradTx,10);
   YPlane(-100,100,100,300,40,GouradTx,10);
   YPlane(100,100,300,300,40,GouradTx,10);
   {Wall}
   ZPlane(-300,-80,-100,40,300,GouradTx,1);
   ZPlane(-100,-80,100,40,300,GouradTx,1);
   ZPlane(100,-80,300,40,300,GouradTx,1);
   {Ceiling}
   YPlane(-300,-300,-100,-100,-80,GouradTx,8);
   YPlane(-100,-300,100,-100,-80,GouradTx,8);
   YPlane(100,-300,300,-100,-80,GouradTx,8);
   YPlane(-300,-100,-100,100,-80,GouradTx,8);
   YPlane(-100,-100,100,100,-80,GouradTx,8);
   YPlane(100,-100,300,100,-80,GouradTx,8);
   YPlane(-300,100,-100,300,-80,GouradTx,8);
   YPlane(-100,100,100,300,-80,GouradTx,8);
   YPlane(100,100,300,300,-80,GouradTx,8);
   {Wall}
   XPlane(-100,40,100,60,-300,GouradTx,1);
   XPlane(-100,40,100,60,300,GouradTx,1);
   {Water}
   YPlane(-300,-100,-100,100,60,TrText,2);
   YPlane(-100,-100,100,100,60,TrText,2);
   YPlane(100,-100,300,100,60,TrText,2);
   {Portal plane}
   XPlane(-100,-80,100,40,-300,Portal,2);
   SingleSided(LastPolygon);
   {-------------PASSAGE AND SECOND ROOM---------------}
   Sector(2);
   ZPlane(-300,-80,-500,40,-100,GouradTx,1);
   ZPlane(-300,-80,-500,40,100,GouradTx,1);
   ZPlane(-500,-80,-700,40,-100,GouradTx,1);
   XPlane(-100,-80,100,40,-700,GouradTx,3);
   XPlane(100,-80,300,40,-700,GouradTx,1);
   YPlane(-300,-100,-500,100,40,GouradTx,1);
   YPlane(-500,-100,-700,100,40,GouradTx,1);
   YPlane(-500,100,-700,300,40,GouradTx,1);
   YPlane(-300,-100,-500,100,-80,GouradTx,1);
   YPlane(-500,-100,-700,100,-80,GouradTx,1);
   YPlane(-500,100,-700,300,-80,GouradTx,1);
   ZPlane(-500,-80,-700,40,300,GouradTx,1);
   Sector(1);
end;


{  _______________________________________________________________________
  /                                                                      /
 / Polygon: Define a polygon                                            /
/______________________________________________________________________/ }

procedure Polygon(s: string);
var p,f1,f2,f3: longint;            {This procedure will parse a string   }
    t: string;                      {with 3-6 coords, a polygon type and  }
    l,n: longint;                   {a data field. Optionally, you can    }
    cn: array[1..6] of longint;     {specify 'D' for doublesided polygons,}
    tp,cl,nrp: longint;             {or 'R' to flip the direction of the  }
    dbl,rev: boolean;               {polygon. There is basic error        }
begin                               {handling, but I'm sure it's easy to  }
   p:=1;                            {pass a string that messes everything }
   nrp:=0;                          {up, so be carefull.                  }
   n:=_coords+1;
   tp:=0;
   cl:=0;
   if s[1]='D' then begin
      inc(p);
      dbl:=True;
   end else Dbl:=False;
   if s[1]='R' then begin
      inc(p);
      rev:=True;
   end else Rev:=False;
   if s[1]=' ' then inc(p);
   repeat
      inc(p);
      t:='';
      repeat
         t:=t+s[p];
         inc(p);
      until (s[p]=',') or (p>length(s));
      f1:=s2n(t);
      t:='';
      inc(p);
      repeat
         t:=t+s[p];
         inc(p);
      until (s[p]=',') or (p>length(s));
      f2:=s2n(t);
      t:='';
      inc(p);
      repeat
         t:=t+s[p];
         inc(p);
      until (s[p]=']') or (p>length(s));
      if p>length(s) then error('Could not parse coordstring','Polygon');
      f3:=s2n(t);
      p:=p+1;
      inc(nrp);
      cn[nrp]:=FindCoord(f1,f2,f3);
   until (p>length(s)) or (s[p]=':');
   if s[p]=':' then begin
      inc(p);
      t:='';
      repeat
         t:=t+s[p];
         inc(p);
      until (p>length(s)) or (s[p]=',');
      t:=upper(t);
      tp:=0;
      if t='PHONG' then tp:=PHONG;
      if t='TEXTURED' then tp:=TEXTURED;
      if t='PLAIN' then tp:=PLAIN;
      if t='GOURADTX' then tp:=GOURADTX;
      if t='GOURAD' then tp:=GOURAD;
      if t='TRTEXT' then tp:=TRTEXT;
      if t='ENVMAP' then tp:=ENVMAP;
      if t='FASTTEXT' then tp:=FASTTEXT;
      if t='FASTTRTX' then tp:=FASTTRTX;
      if t='PORTAL' then tp:=PORTAL;
      if t='REVPORTAL' then tp:=REVPORTAL;
      if tp=0 then Error('Unknown polygon type in coordstring','Polygon');
      if s[p]<>',' then Error('No data specified for polygon','Polygon');
      t:='';
      inc(p);
      while (s[p]>='0') and (s[p]<='9') and (p<=length(s)) do begin
         t:=t+s[p];
         inc(p);
      end;
      cl:=s2n(t);
      if (cl=0) and (t[1]<>'0') then Error('Could not determine data','Polygon');
      if (upper(s[length(s)])='D') then dbl:=True;
      if (upper(s[length(s)])='R') then rev:=True;
   end else Error('No polygon type specified in coordstring','Polygon');
   if nrp<3 then Error('Too few coords in coordstring','Coords');
   if nrp=3 then begin {ugly bug fix}
      nrp:=4;
      cn[4]:=cn[3];
   end;
   if rev then begin
      if nrp=4 then CreatePolygon(cn[4],cn[3],cn[2],cn[1],tp,cl);
      if nrp=5 then Create5Plane(cn[5],cn[4],cn[3],cn[2],cn[1],tp,cl);
      if nrp=6 then Create6Plane(cn[6],cn[5],cn[4],cn[3],cn[2],cn[1],tp,cl);
   end else begin
      if nrp=4 then CreatePolygon(cn[1],cn[2],cn[3],cn[4],tp,cl);
      if nrp=5 then Create5Plane(cn[1],cn[2],cn[3],cn[4],cn[5],tp,cl);
      if nrp=6 then Create6Plane(cn[1],cn[2],cn[3],cn[4],cn[5],cn[6],tp,cl);
   end;
   if nrp>6 then Error('Too many coords in coordstring','Coords');
   if dbl then DoubleSided(_polies);
end;


{  _______________________________________________________________________
  /                                                                      /
 / ZPlane: Define a vertical plane                                      /
/______________________________________________________________________/ }

procedure ZPlane(x1,y1,x2,y2,z1,tp,cl: longint);
var c1,c2,c3,c4: longint;
begin
   c1:=FindCoord(x1,y1,z1);
   c2:=FindCoord(x2,y1,z1);
   c3:=FindCoord(x2,y2,z1);
   c4:=FindCoord(x1,y2,z1);
   CreatePolygon(c2,c3,c4,c1,tp,cl);
   DoubleSided(_polies);
end;


{  _______________________________________________________________________
  /                                                                      /
 / YPlane: Define a horizontal plane                                    /
/______________________________________________________________________/ }

procedure YPlane(x1,z1,x2,z2,y1,tp,cl: longint);
var c1,c2,c3,c4: longint;
begin
   c4:=FindCoord(x1,y1,z1);
   c3:=FindCoord(x2,y1,z1);
   c2:=FindCoord(x2,y1,z2);
   c1:=FindCoord(x1,y1,z2);
   CreatePolygon(c1,c2,c3,c4,tp,cl);
   DoubleSided(_polies);
end;


{  _______________________________________________________________________
  /                                                                      /
 / XPlane: Define a vertical plane (constant x)                         /
/______________________________________________________________________/ }

procedure XPlane(z1,y1,z2,y2,x1,tp,cl: longint);
var c1,c2,c3,c4: longint;
begin
   c4:=FindCoord(x1,y1,z1);
   c3:=FindCoord(x1,y2,z1);
   c2:=FindCoord(x1,y2,z2);
   c1:=FindCoord(x1,y1,z2);
   CreatePolygon(c1,c2,c3,c4,tp,cl);
   DoubleSided(_polies);
end;


{  _______________________________________________________________________
  /                                                                      /
 / MirrorCube: Define a cube with two mirrors on it                     /
/______________________________________________________________________/ }

procedure MirrorCube(x1,y1,z1,h,w,d,tp: longint; cl: word);
var c1: word;
begin
   c1:=_coords;
   CreateCoord(x1,y1,z1);
   CreateCoord(x1+w,y1,z1);
   CreateCoord(x1+w,y1+h,z1);
   CreateCoord(x1,y1+h,z1);
   CreateCoord(x1,y1,z1+d);
   CreateCoord(x1+w,y1,z1+d);
   CreateCoord(x1+w,y1+h,z1+d);
   CreateCoord(x1,y1+h,z1+d);
   CreateCoord(x1+20,y1+20,z1+10);
   CreateCoord(x1+w-20,y1+20,z1+10);
   CreateCoord(x1+w-20,y1+h-20,z1+10);
   CreateCoord(x1+20,y1+h-20,z1+10);
   CreateCoord(x1+20,y1+20,z1+d-10);
   CreateCoord(x1+w-20,y1+20,z1+d-10);
   CreateCoord(x1+w-20,y1+h-20,z1+d-10);
   CreateCoord(x1+20,y1+h-20,z1+d-10);
   CreatePolygon(c1+1,c1+4,c1+8,c1+5,tp,cl);
   CreatePolygon(c1+6,c1+7,c1+3,c1+2,tp,cl);
   CreatePolygon(c1+5,c1+6,c1+2,c1+1,tp,cl);
   CreatePolygon(c1+4,c1+3,c1+7,c1+8,tp,cl);
   CreatePolygon(c1+9,c1+10,c1+11,c1+12,tp,0);
   CreatePolygon(c1+16,c1+15,c1+14,c1+13,tp,0);
   CreatePolygon(c1+1,c1+2,c1+10,c1+9,tp,0);
   CreatePolygon(c1+2,c1+3,c1+11,c1+10,tp,0);
   CreatePolygon(c1+3,c1+4,c1+12,c1+11,tp,0);
   CreatePolygon(c1+4,c1+1,c1+9,c1+12,tp,0);
   CreatePolygon(c1+8,c1+7,c1+15,c1+16,tp,0);
   CreatePolygon(c1+7,c1+6,c1+14,c1+15,tp,0);
   CreatePolygon(c1+6,c1+5,c1+13,c1+14,tp,0);
   CreatePolygon(c1+5,c1+8,c1+16,c1+13,tp,0);
end;


{  _______________________________________________________________________
  /                                                                      /
 / Bar3D: Define a block in 3D                                          /
/______________________________________________________________________/ }

function Bar3D(x1,y1,z1,w,h,d,tp: longint; cl: byte): word;
var c1: word;
    x2,y2,z2: single;
begin
   x2:=x1+w;
   y2:=y1+h;
   z2:=z1+d;
   c1:=_coords;
   CreateCoord(x1,y1,z1);
   CreateCoord(x2,y1,z1);
   CreateCoord(x2,y2,z1);
   CreateCoord(x1,y2,z1);
   CreateCoord(x1,y1,z2);
   CreateCoord(x2,y1,z2);
   CreateCoord(x2,y2,z2);
   CreateCoord(x1,y2,z2);
   CreatePolygon(c1+1,c1+2,c1+3,c1+4,tp,cl);
   CreatePolygon(c1+8,c1+7,c1+6,c1+5,tp,cl);
   CreatePolygon(c1+1,c1+4,c1+8,c1+5,tp,cl);
   CreatePolygon(c1+6,c1+7,c1+3,c1+2,tp,cl);
   CreatePolygon(c1+5,c1+6,c1+2,c1+1,tp,cl);
   CreatePolygon(c1+4,c1+3,c1+7,c1+8,tp,cl);
   Bar3D:=_polies-5;
end;


{  _______________________________________________________________________
  /                                                                      /
 / CreatePul: Define a beerglass (by PITBULL)                           /
/______________________________________________________________________/ }

procedure CreatePul(t: Longint);
{By PITBULL}
const bekersize      = 10;
      bekermul       = 360 div bekersize;
      bekerheigth    = 8;
      bekerhmul      = 25;
      beginstraal    = 110;
      straal_subber  = 7;
      beker_y_offset = 80;
var   f,stral,yy1 : Integer;
begin
   stral:=beginstraal;
   for yy1:=bekerheigth downto 0 do begin
      for f:=0 to bekersize-1 do begin
         CreateCoord(trunc(stral*sin(f*bekermul*3.14/180)),
                     yy1*bekerhmul-beker_y_offset,
                     trunc(stral*cos(f*bekermul*3.14/180)));
      end;
      dec(stral,straal_subber);
   end;
   for yy1:=0 to bekerheigth-1 do begin
      for f:=1 to bekersize-1 do begin
         CreatePolygon(f+1+(bekersize*   yy1),
                       f+1+(bekersize*(1+yy1)),
                       f+  (bekersize*(1+yy1)),
                       f+  (bekersize*   yy1),t,Random(100));
      end;
   end;
   for yy1:=0 to bekerheigth-1 do begin
      for f:=bekersize-1 to bekersize do begin
         CreatePolygon(1+        (bekersize* yy1),
                       1+        (bekersize*(yy1+1)),
                       bekersize+(bekersize*(yy1+1)),
                       bekersize+(bekersize* yy1),t,Random(100));
      end;
   end;
   for f:=1 to bekersize-1 do begin
      CreatePolygon(f+(bekersize*bekerheigth),
                    (bekersize*bekerheigth)+1,
                    (bekersize*bekerheigth)+1,
                    f+1+(bekersize*bekerheigth),
                    t,Random(100));
      CreatePolygon(bekersize+1,bekersize+1,f+1+bekersize,f+bekersize,
                    t,Random(100));
   end;
   { en het handvat }
   CreateCoord(130,0,30);    { nummer 91 }
   CreateCoord(130,0,-30);   {92}
   CreateCoord(110,15,30);   {93}
   CreateCoord(110,15,-30);  {94}
   CreatePolygon(91,13,14,92,t,Random(100)); { OORTJE BOVEN/BENEDEN KANT }
   CreatePolygon(64,63,91,92,t,Random(100));
   CreatePolygon(94,24,23,93,t,Random(100));
   CreatePolygon(93,54,53,94,t,Random(100));
   CreatePolygon(13,91,93,23,t,Random(100)); { OORTJE LINKS/RECHTS KANT }
   CreatePolygon(53,93,91,63,t,Random(100));
   CreatePolygon(24,94,92,14,t,Random(100));
   CreatePolygon(64,92,94,54,t,Random(100));
end;


{  _______________________________________________________________________
  /                                                                      /
 / ReadASC: Read a 3D Studio .ASC file                                  /
/______________________________________________________________________/ }

procedure ReadASC(s: string; tp: longint; sz: single);
var f: text;
    st: string;
    p1,p2,v1,v2: longint;
    r1,r2,r3: single;
    f1,f2,f3: longint;
    dum: integer;
    i: longint;

function ssub(st: string; p,l: integer): string;  {substring function}
var rs: string; i: integer;
begin rs:=''; for i:=0 to l-1 do rs:=rs+st[i+p]; ssub:=rs end;

function sscan(st1,st2: string): longint;
var i,l: longint;
    found: boolean;
begin
   for i:=1 to length(st1)-length(st2)+1 do begin
      found:=True;
      for l:=1 to length(st2) do if st1[(i+l)-1]<>st2[l] then found:=False;
      if found then begin
         sscan:=i;
         i:=length(st1)-length(st2)+1;
      end;
   end;
end;

begin
   assign(f,s);
   reset(f);
   {first look for line with number of vertices and faces}
   st:='';
   while (not eof(f)) and (ssub(st,1,19)<>'Tri-mesh, Vertices:') do readln(f,st);
   if eof(f) then error('Could not find start of object in .ASC file','ReadASC');
   v1:=s2n(ssub(st,sscan(st,'ices:')+5,5));   {number of vertices}
   v2:=s2n(ssub(st,sscan(st,'aces:')+5,5));   {number of faces}
   {Search first vertex from the list}
   st:='';
   while (not eof(f)) and (ssub(st,1,6)<>'Vertex') do readln(f,st);
   for i:=0 to v1-1 do begin
      if eof(f) then Error('Tried to read past end of file','ReadASC');
      readln(f,st);
      {Make sure it's a vertex line (skip page breaks and stuff)}
      while (ssub(st,1,6)<>'Vertex') or (length(st)<7) do readln(f,st);
      {Read x/y/z from current string}
      p1:=sscan(st,'X:')+2;
      p2:=sscan(st,'Y:');
      val(ssub(st,p1,p2-p1),r1,dum);
      p1:=p2+2;
      p2:=sscan(st,'Z:');
      val(ssub(st,p1,p2-p1),r2,dum);
      p1:=p2+2;
      val(ssub(st,p1,12),r3,dum);
      CreateCoord(r1*sz,r2*sz,r3*sz);
   end;
   while (not eof(f)) and (ssub(st,1,9)<>'Face list') do readln(f,st);
   for i:=0 to v2-1 do begin
      if eof(f) then Error('Tried to read past end of file','ReadASC');
      readln(f,st);
      while (ssub(st,1,4)<>'Face') or (length(st)<15) do readln(f,st);
      p1:=sscan(st,'A:')+2;
      p2:=sscan(st,'B:');
      val(ssub(st,p1,p2-p1),f1,dum);
      p1:=p2+2;
      p2:=sscan(st,'C:');
      val(ssub(st,p1,p2-p1),f2,dum);
      p1:=p2+2;
      p2:=sscan(st,'AB:');
      val(ssub(st,p1,p2-p1),f3,dum);
      CreateTriangle(f3+1,f2+1,f1+1,tp,255);
   end;
end;


{  _______________________________________________________________________
  /                                                                      /
 / ReadPLG: Read a PLG 3D file  (by PITBULL)                            /
/______________________________________________________________________/ }

procedure ReadPLG(s: string; tp: longint; sz: single);
var f                     : text;
    x,y,z,t,r,fe,nn       : integer;
    aant_vertex,aant_poly : word;
    ch                    : char;
    x1,y1,z1              : single;
    dy                    : string;
    cc: word;
begin
   assign(f,s);
   reset(f);
   repeat     {read multiple saves - By THE PHANTOM}
      cc:=_coords;
      repeat
         read(f,ch);
      until (ch=#32);
      read(f,aant_vertex);
      read(f,aant_poly);
      readln(f);
      for t:=1 to aant_vertex do
      begin
         if eof(f) then Error('Tried to read past end of file','ReadPLG');
         read(f,x1);
         read(f,y1);
         read(f,z1);
         CreateCoord(x1*sz,y1*sz,z1*sz);
         readln(f)
      end;
      for t:=1 to aant_poly do begin
         if eof(f) then Error('Tried to read past end of file','ReadPLG');
         repeat
            read(f,ch);
         until (ch=#32);
         read(f,nn);
         if nn>4 then Error('Surface with more than four coords incountered in PLG','ReadPLG');
         if (nn=3) then
         begin
            read(f,x);
            read(f,y);
            read(f,z);
            CreatePolygon(cc+z+1,cc+y+1,cc+x+1,cc+x+1,tp,0)
         end;
         if (nn=4) then
         begin
            read(f,x);
            read(f,y);
            read(f,z);
            read(f,fe);
            CreatePolygon(cc+fe+1,cc+z+1,cc+y+1,cc+x+1,tp,0)
         end;
         readln(f)
      end;
   until eof(f);
   close(f)
end;


{  _______________________________________________________________________
  /                                                                      /
 / ReadGEM: Read a GEM 3D file  (by PITBULL)                            /
/______________________________________________________________________/ }

procedure ReadGEM(s: string; type_poly: longint; sz: single);
var f                     : text;
    x,y,z,t,r,fe,f5,f6,nn : integer;
    aant_vertex,aant_poly : word;
    aant_linked_vertex    : word;
    ch                    : char;
    x1,y1,z1              : real;
    c1 :word;
begin

   c1:=_coords;
   assign(f,s);
   reset(f);
   read(f,aant_vertex);
   read(f,aant_poly);
   read(f,aant_linked_vertex);
   readln(f);

   for t:=1 to aant_vertex do
   begin
      if eof(f) then Error('Tried to read past end of file','ReadGEM');
      read(f,x1);
      read(f,y1);
      read(f,z1);
      CreateCoord(round(x1*sz),round(y1*sz),round(z1*sz));
      readln(f)
   end;

   for t:=1 to aant_poly do
   begin
      if eof(f) then Error('Tried to read past end of file','ReadGEM');
      read(f,nn);
      if nn>6 then Error('Surface with more than six coords incountered in GEM','ReadGEM');
      if (nn=3) then
      begin
         read(f,x);
         read(f,y);
         read(f,z);
         CreateTriangle(c1+x,c1+y,c1+z,type_poly,0);
      end;
      if (nn=4) then
      begin
         read(f,x);
         read(f,y);
         read(f,z);
         read(f,fe);
         CreatePolygon(c1+x,c1+y,c1+z,c1+fe,type_poly,0);
      end;
      if (nn=5) then
      begin
         read(f,x);
         read(f,y);
         read(f,z);
         read(f,fe);
         read(f,f5);
         Create5Plane(c1+x,c1+y,c1+z,c1+fe,c1+f5,type_poly,0);
      end;
      if (nn=6) then
      begin
         read(f,x);
         read(f,y);
         read(f,z);
         read(f,fe);
         read(f,f5);
         read(f,f6);
         Create6Plane(c1+x,c1+y,c1+z,c1+fe,c1+f5,c1+f6,type_poly,0);
      end;
      readln(f)
   end;
   close(f)
end;


{  _______________________________________________________________________
  /                                                                      /
 / CreateTorus: Define a torus                                          /
/______________________________________________________________________/ }

procedure CreateTorus(t: Longint; b: boolean; size,sizi: integer; cl: longint);
{Sample object}
var i,l,p: longint;
    px,py: array[1..TORUS] of single;
    x1,y1: single;
    v: Boolean;
    cc: longint;
begin
   cc:=_coords;
   v:=True;
   For i:=1 to TORUS do begin
      px[i]:=SIZI*_sn[(i-1)*TORSIZE];
      py[i]:=SIZI*_cs[(i-1)*TORSIZE];
   end;
   for i:=1 to SEGMENTS do begin
      for l:=1 to TORUS do begin
         x1:=(SIZE+px[l])*_sn[(i-1)*STEPSIZE];
         y1:=(SIZE+px[l])*_cs[(i-1)*STEPSIZE];
         CreateCoord(py[l],x1,y1);
      end;
   end;
   for i:=0 to SEGMENTS-2 do begin
      for l:=1 to TORUS-1 do begin
         p:=i*TORUS+l;
         if v or b then begin
            CreatePolygon(cc+p,cc+p+1,cc+p+1+TORUS,cc+p+TORUS,t,cl);
            if not b then DoubleSided(_polies);
         end;
         v:=not v;
      end;
      p:=i*TORUS+TORUS;
      if v or b then begin
         CreatePolygon(cc+p,cc+(p+1)-TORUS,cc+p+1,cc+p+TORUS,t,cl);
         if not b then DoubleSided(_polies);
      end;
      v:=not v;
   end;
   for l:=1 to TORUS-1 do begin
      p:=(SEGMENTS-1)*TORUS+l;
      if v or b then begin
         CreatePolygon(cc+p,cc+p+1,cc+l+1,cc+l,t,cl);
         if not b then DoubleSided(_polies);
      end;
      v:=not v;
   end;
   p:=(SEGMENTS-1)*TORUS+TORUS;
   if v or b then begin
      CreatePolygon(cc+p,cc+(p+1)-TORUS,cc+1,cc+TORUS,t,cl);
      if not b then DoubleSided(_polies);
   end;
end;


{  _______________________________________________________________________
  /                                                                      /
 / Read3DS : Read a 3D-Studio 3.0+ file                                 /
/______________________________________________________________________/ }

procedure Read3DS( s: string; type_poly: longint; sz: single );
const
    TRI_VERTEXL = $4110;
    TRI_FACEL1  = $4120;
    TRI_FACEL2  = $4111;
    TRI_TRANSL  = $0;   {??}
    TRI_VISIBLE = $4165;
    tri_smooth  = $4150;

var f           : file;
    fbuffer     : array [0..33] of byte;
    soort       : integer;
    p           : pointer;
    c1          : longint;
    k_pointer2,k_pointer,
    c_pointer4,c_pointer,c_pointer3,
    c_pointer2,t_pointer,t_pointer2  : longint;

function ReadChar:char;
var ch:char;
begin
   blockread(f,ch,1);
   readchar:=ch;
end;

function ReadInt:integer;
var temp1,temp2 :integer;
begin
   blockread(f,temp1,2);
   temp2  :=         (temp1 and 255) shl 8;
   temp2  :=temp2 + ((temp1 shr 8) and 255);
   readint:=temp1;
end;

function readlong:longint;
var temp1,temp2  :longint;
begin
   blockread(f,temp1,4);
   temp2:=         (temp1         and 255) shl 24;
   temp2:=temp2 + ((temp1 shr 8)  and 255) shl 16;
   temp2:=temp2 + ((temp1 shr 16) and 255) shl 8;
   temp2:=temp2 + ((temp1 shr 24) and 255);
   readlong:=temp1;
end;

procedure readname;
begin
   repeat
   until readchar=#0;
end;

procedure file_seek(var f:file;pttr:longint);assembler;
asm
   mov ax,4201h             -- ax == 4201h -> {DOS fnk relative filemove}
   mov ebx,dword ptr [f]
   mov bx,[ebx+260]         -- the filehandle is found 260 bytes from a
                            -- filebuffer-offset DTA = 256 bytes, 32bit ofs
                            -- and then the filehandle / etcetra
                            -- DTA=disk tranfer area, this problem took me
                            -- one F**KING our to solve
   mov edx,dword ptr [pttr]
   int 21h
end;

procedure discardblock;
begin
   file_seek(f,readlong-6);
end;


{  _______________________________________________________________________
  /                                                                      /
 / Read_Vertices: read all the X,Y,Z pairs                              /
/______________________________________________________________________/ }

procedure read_vertices;
var    current_pointer,temp_pointer : longint;
       vertx_cnt                    : integer;
       vertexen                     : array [0..3] of single;
       k                            : word;
begin
   readlong; {blocklength.. }
   vertx_cnt:=readint;
   for k:=0 to vertx_cnt-1 do
   begin
      blockread(f,vertexen[0],4);
      blockread(f,vertexen[1],4);
      blockread(f,vertexen[2],4);
      CreateCoord(vertexen[0]*sz,vertexen[1]*sz,vertexen[2]*sz);
  --  writeln('coord: x=',vertexen[0]:5:5,' Y=',vertexen[1]:5:5,' Z=',vertexen[2]:5:5);
   end;
end;


{  _______________________________________________________________________
  /                                                                      /
 / Read_Faces : Read each (triangle) face of a object                   /
/______________________________________________________________________/ }

procedure read_faces(c1:word);
var   current_pointer,temp_pointer : longint;
      temp_diff : longint;
      faces     : array [0..6] of word;
      faces_cnt : integer;
      k         : word;
begin
   readlong; {blocklength.. }
   faces_cnt   := readint;
   for k:=0 to faces_cnt-1 do
   begin
      faces[0] := readint;
      faces[1] := readint;
      faces[2] := readint;
      faces[3] := readint;  {This one is redundant for the magic II-engine}
      CreateTriangle(faces[2]+c1+1,faces[1]+c1+1,faces[0]+c1+1,type_poly,0);
   -- writeln('Face: ',k,'=',faces[0]+c1+1,' -> ',faces[1]+c1+1,' -> ',faces[2]+c1+1);
   end;
   if readint=tri_smooth then discardblock;
end;

begin
   c1:=_coords;
   assign(f,s);
   reset(f,1);
   blockread(f,fbuffer,32);

   if fbuffer[28]<>3 then begin
      close(f);
      error('3D-Studio 3.0+ files only','Read3DS');
   end;
   seek(f,16);soort:=readint;
   file_seek(f,4);              { skip length }
   if (soort=$3d3d) then
   begin
      repeat
         soort:=readint;
         c_pointer:=readlong;c_pointer4:=c_pointer+filepos(f);
         file_seek(f,c_pointer-6);          { skip 1ste blok }

         if (soort=$3d3e) then
         begin
            repeat
               soort:=readint;
               c_pointer2:=readlong;
               c_pointer3:=c_pointer2+filepos(f);
               if soort<>$4000 then
                  file_seek(f,c_pointer2-6) { skip blok }
               else
               begin
                  readname;
                  soort:=readint;
                  if soort=$4100 then
                  begin
                     t_pointer :=readlong;   { block-length }
                     t_pointer2:=filepos(f)+t_pointer;
                     repeat
                        soort:=readint;
                        case soort of
                           $4110 : read_vertices;
                           $4120 : read_faces(c1);
                        else
                           discardblock;
                        end;
                     until (filepos(f)>t_pointer2);
                  end;
               end;
            until (filepos(f)>c_pointer3);
         end else
            discardblock;
      until (filepos(f)>c_pointer4);
   end;
   close(f);
end;

end.
