#ifndef  _PAINTER_H
#define  _PAINTER_H

#ifndef  _BALDEF_H
#include "BalDef.h"
#endif


class BBuffer;



#ifdef   _WINDOWS
#include <windows.h>


class BPainter {
private:
    const BBuffer  & m_buffer;
    BITMAPINFO     * m_bmpinfo;

public:
    BPainter (const BBuffer & buffer);
   ~BPainter ();

    BBOOL Paint (HDC hdc, int x, int y);
};



#else
#include <X11/Xlib.h>
#include <X11/Xutil.h>



class BPainter {
private:
    const BBuffer  & m_buffer;
    XImage         * m_image;
    Display        * m_display;


public:
    BPainter (const BBuffer & buffer, Display * disp);
   ~BPainter ();

    BBOOL Paint (Window win, GC gc, int x, int y);
};



#endif



#endif
