#ifndef  _PALMAN_H
#define  _PALMAN_H


#ifndef  _BALDEF_H
#include "BalDef.h"
#endif




class BTexture;



class BPalMan {
private:
    struct BImage {
        BTexture * m_texture;
        BRGB       m_pal [256];
        int        m_palindex [256];
        int        m_pixcount [256];
        int        m_palsize;
        BImage   * m_next;
        };


    struct BEntry {
        BRGB       m_color;
        int        m_pixcount;
        BBOOL      m_deleted;
        };
    
    
    BImage *  m_head;
    int       m_tabsize;
    BEntry *  m_table;
    BRGB      m_pal [256];



private:
    void CreateTable   ();
    void DestroyTable  ();



public:
    BPalMan ();
   ~BPalMan ();


    void AddTexture (BTexture & texture, const BRGB * pal);
    void Optimize ();

    inline const BRGB * GetPalette ()  {return m_pal;}
};





#endif
