#include "Copyright.h"
#include "PalMan.h"
#include "File.h"
#include "Texture.h"
#include "GIFImage.h"




#define TOTALFILE   8




static const char * source [TOTALFILE] = {
    "bricktile.gif",
    "cobble.gif",
    "inlay.gif",
    "marble.gif",
    "redbrick.gif",
    "rock.gif",
    "sky.gif",
    "rustic.gif"
    };


static const char * dest [TOTALFILE] = {
    "bricktile.bif",
    "cobble.bif",
    "inlay.bif",
    "marble.bif",
    "redbrick.bif",
    "rock.bif",
    "sky.bif",
    "rustic.bif"
    };


static const char * palname = "baltimore.pal";



#ifdef _UNIX
int main () {
#endif

#ifdef _WINDOWS
int PASCAL WinMain (HINSTANCE, HINSTANCE, LPSTR, int) {
#endif

    int i;
    BBOOL error = BFALSE;
    BPalMan palman;
    BTexture * texture [TOTALFILE];
    
    
    for (i=0; i<TOTALFILE; i++) {
        BGIFImage image;
        if (image.Load (source[i]) == BFALSE) {
            BMessage ("Error loading GIF files.");
            error = BTRUE;
            break;
            }
        
        texture [i] = new BTexture (image.GetTexture ());
        palman.AddTexture (* texture[i], image.GetPalette ());
        }
    
    
    if (error)
        return 0;
    
    
    BMessage ("GIF Reading Done.");
    palman.Optimize ();
    BMessage ("Palette Optimization Done.");
    
    

    const BRGB * palette = palman.GetPalette ();
    BFile palfile;
    if (palfile.Create (palname) == BFALSE) {
        BMessage ("Error saving palette file.");
        return 0;
        }
    
    for (i=0; i<256; i++) {
        BBYTE byte;
        byte = palette[i].r;  palfile.Write (& byte, 1);
        byte = palette[i].g;  palfile.Write (& byte, 1);
        byte = palette[i].b;  palfile.Write (& byte, 1);
        }
    
    palfile.Close ();
    
    

    for (i=0; i<TOTALFILE; i++) {
        BFile bif;
        if (bif.Create (dest[i]) == BFALSE) {
            BMessage ("Error saving BIF file.");
            return 0;
            }
        

        BBYTE widthshift;
        BBYTE heightshift;
        for (int bit=0; bit<16; bit++) {
            if ((1 << bit) == texture[i]->m_width)
                widthshift = (BBYTE) bit;
            if ((1 << bit) == texture[i]->m_height)
                heightshift = (BBYTE) bit;
            }
        bif.Write (& widthshift,  1);
        bif.Write (& heightshift, 1);


        for (int row=0; row<texture[i]->m_height; row++)
            for (int col=0; col<texture[i]->m_width; col++) {
                BBYTE byte = texture[i]->GetPixel (col, row);
                bif.Write (& byte, 1);
                }
        
        bif.Close ();
        }


    BMessage ("BIF File Writing Done.");
    return 1;
}

