#include "Copyright.h"
#include "Player.h"




BPlayer::BPlayer (const BPoint  & pos,
                  const BVector & normal,
                  const BREAL     height,
                  const BSector * sector) :
    BWalker (pos, normal, height, sector)    {}






void BPlayer::Turn (BREAL rad) {
    BREAL costheta = BCOS (rad);
    BREAL sintheta = BSIN (rad);
    BREAL x = m_normal.x;
    BREAL y = m_normal.y;
    
    View (BVector (x*costheta + y*sintheta, 
                  -x*sintheta + y*costheta));
}



void BPlayer::Forward (BREAL dist) {
    Walk (m_pos + m_normal*(dist/m_normal.Length()));
    return;
}



void BPlayer::Backward (BREAL dist) {
    Walk (m_pos - m_normal*(dist/m_normal.Length()));
    return;
}

