#ifndef  _POINT_H
#define  _POINT_H


#ifndef  _BALDEF_H
#include "BalDef.h"
#endif

#ifndef  _VECTOR_H
#include "Vector.h"
#endif




class BPoint {
public:
    BREAL  x;
    BREAL  y;


    inline BPoint () : x(0.0f), y(0.0f)  {}
    inline BPoint (BREAL px, BREAL py) : x(px),  y(py)   {}
    inline BPoint (const BPoint & p)   : x(p.x), y(p.y)  {}

    
    inline const BPoint & operator = (const BPoint & point) {
        x = point.x;
        y = point.y;
        return * this;
        }


    inline BVector operator - (const BPoint & point) const
        {return BVector (x-point.x, y-point.y);}

    inline BPoint  operator - (const BVector & vector) const
        {return BPoint (x-vector.x, y-vector.y);}

    inline BPoint  operator + (const BVector & vector) const
        {return BPoint (x+vector.x, y+vector.y);}

    inline operator BVector () const
        {return BVector (x, y);}
};



#endif
