#ifndef  _RENGINE_H
#define  _RENGINE_H


#ifndef  _BALDEF_H
#include "BalDef.h"
#endif



class BBuffer;
class BCamera;
class BTexture;
class BLine;
class BSector;
class BPoint;
class BVector;



class BRengine {
private:
    const int    m_width;
    const int    m_height;
    const BREAL  m_projector;
    const BREAL  m_zoomer;
    BVector    * m_raybase;



private:
    void SubRender (BREAL minrow, BREAL maxrow, 
                    const BPoint  & startpoint,
                    const BSector * sector, 
                    BREAL basebeta) const;


    void PaintSector (const BTexture * texture, 
                      BREAL bottomrow, BREAL floorrow, 
                      BREAL xshift,    BREAL yshift,
                      BREAL level) const;


    void PaintWall   (const BTexture * texture,
                      BREAL minlevel,   BREAL maxlevel,
                      BREAL xshift,     BREAL yshift,
                      BREAL perspector, BREAL alphalen) const;



public:
    BRengine (int width, int height, 
              BREAL distance, BREAL projector);
   ~BRengine ();


    void  Render (BBuffer & buffer, const BCamera & camera) const;
};





#endif
