/*---------------------------------------------------------------------------
                      THE CHAOS ENGINE - TEXT.C

    Routines to display strings and numbers in a linear framebuffer.
---------------------------------------------------------------------------*/

#include <stdio.h>

#define TEXT

extern char sfont, *gfxbuffer;
extern int xsize;

int textx,texty,textpos;
char textcolor;

// Offsets into font data

//            !    "    # $    %    & '    (    )    *    +    ,    -
int cvttab[]={2296,2856,0,2968,2912,0,2688,2744,2800,2520,2408,2240,2464,
//              .    /    0    1    2    3    4    5    6    7    8    9
                2184,2576,1624,1680,1736,1792,1848,1904,1960,2016,2072,2128,
//              :    ; < =    > ?    @    A B  C   D   E   F   G   H   I
                2632,0,0,3080,0,2352,3136,0,56,112,168,224,280,336,392,448,
//              J   K   L   M   N   O   P   Q   R   S    T    U    V    W
                504,560,616,672,728,784,840,896,952,1008,1064,1120,1176,1232,
//              X    Y    Z
                1288,1344,1400};

#pragma aux PutC=   " cmp   al, 32               ",\
                    " jb    NoChar               ",\
                    " je    Space                ",\
                    " sub   eax, 33              ",\
                    " mov   esi, offset sfont    ",\
                    " mov   edi, [gfxbuffer]     ",\
                    " add   esi, cvttab[eax*4]  ",\
                    " add   edi, textpos         ",\
                    " mov   cl, 8                ",\
                    " mov   ah, textcolor        ",\
                    "YLoop:                      ",\
                    " mov   ch, 7                ",\
                    "XLoop:                      ",\
                    " mov   al, [esi]            ",\
                    " inc   esi                  ",\
                    " cmp   al, 1                ",\
                    " jb    NoPix                ",\
                    " ja    Color                ",\
                    " mov   [edi], al            ",\
                    " jmp   NoPix                ",\
                    "Color:                      ",\
                    " mov   [edi], ah            ",\
                    "NoPix:                      ",\
                    " inc   edi                  ",\
                    " dec   ch                   ",\
                    " jnz   XLoop                ",\
                    " add   edi, xsize            ",\
                    " sub   edi, 7               ",\
                    " dec   cl                   ",\
                    " jnz   YLoop                ",\
                    "Space:                      ",\
                    " add   textpos, 7           ",\
                    "NoChar:                     ",\
                    parm[eax] modify[eax ecx esi edi];


void SetTextColor(int c)
{
textcolor=c;
}

void PutChar(char col, char c)
{
textcolor=col;
PutC(c);
}

void PutCharXY(int x, int y, char c)
{
textpos=y*xsize+x;
PutC(c);
}

void PutString(char c, char *str)
{
textcolor=c;
while(*str!=NULL) PutC(*str++);
}

void PutStringXY(int x, int y, char c, char *str)
{
textpos=y*xsize+x;
textcolor=c;
while(*str!=NULL) PutC(*str++);
}

void PutInt(char c, int value)
{
char str[16];
ltoa(value, str, 10);
PutString(c,&str);
}

void PutIntXY(int x, int y, char c, int value)
{
char str[16];
ltoa(value, str, 10);
PutStringXY(x,y,c,&str);
}

