Program Textures;
{TEXTURE COMPILER - Converts 128x128/24bit TARGA tiles to big map}
var map: Array[0..256*128*3+2048] of byte;
    tile: Array[0..51000] of byte;
    f: file;

procedure ReadTexture(s: string; x,y: longint);
var f: file;
    p: pointer;
    h,v: longint;
    a,b: dword;
begin
   Writeln(' Reading texture "'+s+'"');
   p:=@tile;
   Assign(f,s);
   Reset(f,1);
   BlockRead(f,p^,49170);
   Close(f);
   Writeln(' Adding to output map');
   for h:=0 to 127 do for v:=0 to 127 do begin
      a:=(h+x)*3+(v+y)*256*3;
      b:=h*3+v*128*3+18;
      map[a]:=tile[b];       {R}
      map[a+1]:=tile[b+1];   {G}
      map[a+2]:=tile[b+2];   {B}
   end;
end;

procedure TGAHeader;
var i: longint;
    f: file;
    p: pointer;
begin
   {Use last read tile as template for header}
   p:=@tile;
   Assign(f,'tiles\stonetib.tga');  {dummy file}
   Reset(f,1);
   BlockRead(f,p^,18);
   Close(f);
   for i:=0 to 17 do map[i]:=tile[i];
   map[12]:=0;
   map[13]:=1;   {256}
   map[14]:=0;
   map[15]:=4;   {512+512}
end;

procedure TGATail;
var i: longint;
    b,a: dword;
begin
   {Use last read tile as template for trailer}
   a:=18+256*512*3;
   b:=18+128*128*3;
   for i:=0 to 1034 do map[a+i]:=tile[b+i];
end;

procedure SaveHeader(s: string);
var p: pointer;
    len: longint;
begin
   Assign(f,s);
   Rewrite(f,1);
   p:=@map;
   len:=18;
   BlockWrite(f,p^,len);
end;

procedure AppendTextures;
var p: pointer;
    len: longint;
begin
   p:=@map;
   len:=256*128*3;
   BlockWrite(f,p^,len);
end;

begin
   Writeln('Constructing compiled texture map...');
   TGAHeader;
   SaveHeader('tiles.tga');
   ReadTexture('tiles\stonetib.tga',0,0);
   ReadTexture('tiles\stoneti7.tga',128,0);
   AppendTextures;
   ReadTexture('tiles\plaster1.tga',0,0);
   ReadTexture('tiles\woodtil2.tga',128,0);
   AppendTextures;
   ReadTexture('tiles\stonetia.tga',0,0);
   ReadTexture('tiles\plaster5.tga',128,0);
   AppendTextures;
   ReadTexture('tiles\water6.tga',0,0);
   ReadTexture('tiles\wood12.tga',128,0);
   AppendTextures;
   ReadTexture('tiles\karin.tga',0,0);
   ReadTexture('tiles\design11.tga',128,0);
   AppendTextures;
   ReadTexture('tiles\brick30.tga',0,0);
   ReadTexture('tiles\water2.tga',128,0);
   AppendTextures;
   ReadTexture('tiles\stone23.tga',0,0);
   ReadTexture('tiles\stone7.tga',128,0);
   AppendTextures;
   ReadTexture('tiles\stone44.tga',0,0);
   ReadTexture('tiles\misc4.tga',128,0);
   AppendTextures;
   Close(f);
   Writeln('Ready.');
end.
