/*---------------------------------------------------------------------------
                        THE CHAOS ENGINE - TIMER.C

                      Protected mode timer routines.
---------------------------------------------------------------------------*/

#include <stdio.h>
#include <dos.h>

#define TIMER

#include "timer.h"

unsigned int micros;
char microtimer_installed=FALSE;

/*---------------------------------------------------------------------------
                1193181 Ticks per second timer routines
---------------------------------------------------------------------------*/

void Init_MicroTimer(void)
{
outp(0x43, 0x34);
outp(0x40, NULL);
outp(0x40, NULL);
printf("Microsecond Timer Installed...\n");
microtimer_installed=TRUE;
}

void Remove_MicroTimer(void)
{
if (microtimer_installed) {
   outp(0x43, 0x36);
   outp(0x40, NULL);
   outp(0x40, NULL);
}
}

#pragma aux Read_Time=\
                     "cli",\
                     "mov   dx, 20h",\
                     "mov   al, 0ah",\
                     "out   dx, al",\
                     "xor   al, al",\
                     "out   043h, al",\
                     "in    al, dx",\
                     "mov   edi, eax",\
                     "in    al, 40h",\
                     "mov   bl, al",\
                     "in    al, 40h",\
                     "mov   bh, al",\
                     "not   ebx",\
                     "in    al, 21h",\
                     "mov   esi, eax",\
                     "mov   al, 0ffh",\
                     "out   21h, al",\
                     \
                     "mov   ebp, 046ch",\
                     "mov   dx, [ebp]",\
                     "mov   eax, esi",\
                     "out   21h, al",\
                     "sti",\
                     \
                     "test  edi, 1",\
                     "jz    Done",\
                     "cmp   bx, 0ffh",\
                     "ja    Done",\
                     "inc   dx",\
               "Done:",\
                     "shl   edx,16",\
                     "mov   dx, bx",\
                     modify [eax ebx edx edi esi ebp] value [edx]

// Reset microtimer

void Reset_MicroTimer(void)
{
micros=Read_MicroTimer();
}

// Read ticks

unsigned int Read_MicroTimer(void)
{
return(Read_Time());
}

// Returns ticks since last call to Reset_MicroTimer()

unsigned int Elapsed_Ticks(void)
{
return(Read_MicroTimer()-micros);
}
