#include "stuff.h"
#include "shared.h"
#include "fmath\fmath.h"
#include "vesa\vesa.h"
#include "trivesa.h"

int slope[1024],
    slopec[1024],
    slopetx[1024],slopety[1024],
    slopenx[1024],slopeny[1024],slopenz[1024],
    slopez[1024];
    
byte *specular,*bmpspec;
extern byte *rgb;
dword *zbuffer;

_VESAtritype _VESAtri;

#pragma aux swap=\
        "mov eax,[esi]"\
        "xchg [edi],eax"\
        "mov [esi],eax"\
        parm [esi] [edi];
        
void init_VESAtrih(void){
/*
   slope=(int *)malloc(4*480);
   slopec=(int *)malloc(4*480);
   slopez=(int *)malloc(4*480); // zbuffer
   slopetx=(int *)malloc(4*480);
   slopety=(int *)malloc(4*480);
   slopenx=(int *)malloc(4*480);
   slopeny=(int *)malloc(4*480);
   slopenz=(int *)malloc(4*480); // 4*240*2
  */ 
}

//
//                            TEXTURE-MAPPING
//

void VESAhline_texture(int x1,int x2,int y,int tx1,int ty1,int tx2,int ty2){
    int txp,txs,typ,tys,i,p;
    if (x1==x2) return;
    if (x2<x1){
        swap(&x1,&x2);
        swap(&tx1,&tx2);
        swap(&ty1,&ty2);
    }
    txs=(tx2-tx1)/(x2-x1); txp=tx1;
    tys=(ty2-ty1)/(x2-x1); typ=ty1;
    if (x1>clipx2) return;
    if (x2<clipx1) return;
    if (x1<clipx1){
        i=(clipx1-x1);
        txp+=i*txs;
        typ+=i*tys;
        x1=clipx1;
    }
    if (x2>clipx2) x2=clipx2;
    p=(y*scrX)+x1;
    for (i=x1;i<x2;i++){
        VESAbufrw[p++]=_VESAtri.pic[(((typ>>16)*256)+(txp>>16))];
        txp+=txs;
        typ+=tys;
    }    
}

void VESAcalcslope_texture(int x1,int y1,int tx1,int ty1,int x2,int y2,int tx2,int ty2,int add){
    int i,jmp,xp,xs,txp,txs,typ,tys;
    if (y1>y2){
        swap(&y1,&y2);
        swap(&x1,&x2);
        swap(&tx1,&tx2);
        swap(&ty1,&ty2);
    }
    if (y1==y2) if ((y1>clipy1)&&(y2<clipy2)){ 
        slope[y1<<1]=x1<<16; 
        slopetx[y1<<1]=tx1<<16; 
        slopety[y1<<1]=ty1<<16; 
        slope[(y1<<1)+1]=x2<<16; 
        slopetx[(y1<<1)+1]=tx2<<16; 
        slopety[(y1<<1)+1]=ty2<<16; 
        return; 
    } else return;
    xs=((x2-x1)<<16)/(y2-y1); xp=x1<<16;
    txs=((tx2-tx1)<<16)/(y2-y1); txp=tx1<<16;
    tys=((ty2-ty1)<<16)/(y2-y1); typ=ty1<<16;
//== clipping y =============================================================
    if (y1<clipy1){
        i=clipy1-y1;
        y1=clipy1;
        xp+=(xs*i);
        txp+=(txs*i);
        typ+=(tys*i);
    }
    if (y2>clipy2) y2=clipy2;
//===========================================================================
    if (miny>y1) miny=y1; if (maxy<y2) maxy=y2;
    for (i=y1;i<=y2;i++){
        slope[(i<<1)+add]=xp;
        slopetx[(i<<1)+add]=txp;
        slopety[(i<<1)+add]=typ;
        xp+=xs;
        txp+=txs;
        typ+=tys;
    }
}

void VESAtri_texture(void){
   int i,add=0,lx1,lx2,tx1,tx2,ty1,ty2;
   miny=32768;
   maxy=-32768;
   if (_VESAtri.y2<_VESAtri.y1){ swap(&_VESAtri.y1,&_VESAtri.y2); swap(&_VESAtri.x1,&_VESAtri.x2); swap(&_VESAtri.tx1,&_VESAtri.tx2); swap(&_VESAtri.ty1,&_VESAtri.ty2); }
   if (_VESAtri.y3<_VESAtri.y1){ swap(&_VESAtri.y1,&_VESAtri.y3); swap(&_VESAtri.x1,&_VESAtri.x3); swap(&_VESAtri.tx1,&_VESAtri.tx3); swap(&_VESAtri.ty1,&_VESAtri.ty3); }
   if (_VESAtri.y3<_VESAtri.y2){ swap(&_VESAtri.y2,&_VESAtri.y3); swap(&_VESAtri.x2,&_VESAtri.x3); swap(&_VESAtri.tx2,&_VESAtri.tx3); swap(&_VESAtri.ty2,&_VESAtri.ty3); }
   if (_VESAtri.x2>_VESAtri.x3) add=1;
   VESAcalcslope_texture(_VESAtri.x1,_VESAtri.y1,_VESAtri.tx1,_VESAtri.ty1,_VESAtri.x2,_VESAtri.y2,_VESAtri.tx2,_VESAtri.ty2,add);
   VESAcalcslope_texture(_VESAtri.x2,_VESAtri.y2,_VESAtri.tx2,_VESAtri.ty2,_VESAtri.x3,_VESAtri.y3,_VESAtri.tx3,_VESAtri.ty3,add);
   VESAcalcslope_texture(_VESAtri.x3,_VESAtri.y3,_VESAtri.tx3,_VESAtri.ty3,_VESAtri.x1,_VESAtri.y1,_VESAtri.tx1,_VESAtri.ty1,add^1);
   for (i=miny;i<=maxy;i++){
       lx1=slope[i<<1]>>16; 
       lx2=slope[(i<<1)+1]>>16; 
       tx1=slopetx[i<<1]; 
       tx2=slopetx[(i<<1)+1]; 
       ty1=slopety[i<<1]; 
       ty2=slopety[(i<<1)+1]; 
       VESAhline_texture(lx1,lx2,i,tx1,ty1,tx2,ty2);
   }    
}

//
//                        PERSPECTIVE TEXTURE-MAPPING
//

void VESAhline_pstexture(int x1,int x2,int y,int tx1,int ty1,int nz1,int tx2,int ty2,int nz2){
    int txp,txs,typ,tys,i,p,nzs,nzp;
    int tx,ty;
    if (x1==x2) return;
    if (x2<x1){
        swap(&x1,&x2);
        swap(&tx1,&tx2);
        swap(&ty1,&ty2);
        swap(&nz1,&nz2);
    }
    txs=(tx2-tx1)/(x2-x1); txp=tx1;
    tys=(ty2-ty1)/(x2-x1); typ=ty1;
    nzs=(nz2-nz1)/(x2-x1); nzp=nz1;
    if (x1>clipx2) return;
    if (x2<clipx1) return;
    if (x1<clipx1){
        i=(clipx1-x1);
        txp+=i*txs;
        typ+=i*tys;
        nzp+=i*nzs;
        x1=clipx1;
    }
    if (x2>clipx2) x2=clipx2;
    p=(y*scrX)+x1;
    if (nzp==0) nzp=1;
    for (i=x1;i<x2;i++){
        tx=txp/nzp;
        ty=typ/nzp;
        VESAbufrw[p++]=_VESAtri.pic[(ty<<8)+tx];
        txp+=txs;
        typ+=tys;
        nzp+=nzs;
    }    
}

void VESAcalcslope_pstexture(int x1,int y1,int nz1,int tx1,int ty1,int x2,int y2,int nz2,int tx2,int ty2,int add){
    int i,jmp,xp,xs,txp,txs,typ,tys,np,ns;
    if (y1>y2){
        swap(&y1,&y2);
        swap(&x1,&x2);
        swap(&tx1,&tx2);
        swap(&ty1,&ty2);
        swap(&nz1,&nz2);
    }
    if (y1==y2) if ((y1>clipy1)&&(y2<clipy2)){ 
        slope[y1<<1]=x1<<16; 
        slopetx[y1<<1]=tx1;
        slopety[y1<<1]=ty1;
        slopenz[y1<<1]=nz1;
        slope[(y1<<1)+1]=x2<<16;
        slopetx[(y1<<1)+1]=tx2;
        slopety[(y1<<1)+1]=ty2;
        slopenz[(y1<<1)+1]=nz2;
        return;
    } else return;
    xs=((x2-x1)<<16)/(y2-y1); xp=x1<<16;
    txs=((tx2-tx1))/(y2-y1); txp=tx1;
    tys=((ty2-ty1))/(y2-y1); typ=ty1;
    ns=((nz2-nz1))/(y2-y1); np=nz1;
//== clipping y =============================================================
    if (y1<clipy1){
        i=clipy1-y1;
        y1=clipy1;
        xp+=(xs*i);
        txp+=(txs*i);
        typ+=(tys*i);
        np+=(ns*i);
    }
    if (y2>clipy2) y2=clipy2;
//===========================================================================
    if (miny>y1) miny=y1; if (maxy<y2) maxy=y2;
    for (i=y1;i<=y2;i++){
        slope[(i<<1)+add]=xp;
        slopetx[(i<<1)+add]=txp;
        slopety[(i<<1)+add]=typ;
        slopenz[(i<<1)+add]=np;
        xp+=xs;
        txp+=txs;
        typ+=tys;
        np+=ns;
    }
}

void VESAtri_pstexture(void){
   int i,add=0,lx1,lx2,tx1,tx2,ty1,ty2,nz1,nz2;
   int z1,z2,z3,rz1,rz2,rz3,txz1,tyz1,txz2,tyz2,txz3,tyz3;
   miny=32768;
   maxy=-32768;
   if (_VESAtri.y2<_VESAtri.y1){ swap(&_VESAtri.y1,&_VESAtri.y2); swap(&_VESAtri.x1,&_VESAtri.x2); swap(&_VESAtri.z1,&_VESAtri.z2); swap(&_VESAtri.tx1,&_VESAtri.tx2); swap(&_VESAtri.ty1,&_VESAtri.ty2); }
   if (_VESAtri.y3<_VESAtri.y1){ swap(&_VESAtri.y1,&_VESAtri.y3); swap(&_VESAtri.x1,&_VESAtri.x3); swap(&_VESAtri.z1,&_VESAtri.z3); swap(&_VESAtri.tx1,&_VESAtri.tx3); swap(&_VESAtri.ty1,&_VESAtri.ty3); }
   if (_VESAtri.y3<_VESAtri.y2){ swap(&_VESAtri.y2,&_VESAtri.y3); swap(&_VESAtri.x2,&_VESAtri.x3); swap(&_VESAtri.z2,&_VESAtri.z3); swap(&_VESAtri.tx2,&_VESAtri.tx3); swap(&_VESAtri.ty2,&_VESAtri.ty3); }
   if (_VESAtri.x2>_VESAtri.x3) add=1;
   rz1=_VESAtri.z1;
   rz2=_VESAtri.z2;
   rz3=_VESAtri.z3;
   z1=fixdiv(65536,rz1); // 1/z est linaire aprs la projection
   z2=fixdiv(65536,rz2); // u/z aussi et v/z aussi
   z3=fixdiv(65536,rz3);
   txz1=fixdiv(_VESAtri.tx1<<16,rz1); // les (u,v) se calculent:
   txz2=fixdiv(_VESAtri.tx2<<16,rz2); // u=(u/z)/(1/z)
   txz3=fixdiv(_VESAtri.tx3<<16,rz3); // v=(v/z)/(1/z)
   tyz1=fixdiv(_VESAtri.ty1<<16,rz1); // donc on interpole u/z, v/z et 1/z
   tyz2=fixdiv(_VESAtri.ty2<<16,rz2);
   tyz3=fixdiv(_VESAtri.ty3<<16,rz3);
   VESAcalcslope_pstexture(_VESAtri.x1,_VESAtri.y1,z1,txz1,tyz1,_VESAtri.x2,_VESAtri.y2,z2,txz2,tyz2,add);
   VESAcalcslope_pstexture(_VESAtri.x2,_VESAtri.y2,z2,txz2,tyz2,_VESAtri.x3,_VESAtri.y3,z3,txz3,tyz3,add);
   VESAcalcslope_pstexture(_VESAtri.x3,_VESAtri.y3,z3,txz3,tyz3,_VESAtri.x1,_VESAtri.y1,z1,txz1,tyz1,add^1);
   for (i=miny;i<=maxy;i++){
       lx1=slope[i<<1]>>16; 
       lx2=slope[(i<<1)+1]>>16; 
       tx1=slopetx[i<<1]; 
       tx2=slopetx[(i<<1)+1]; 
       ty1=slopety[i<<1]; 
       ty2=slopety[(i<<1)+1]; 
       nz1=slopenz[i<<1]; 
       nz2=slopenz[(i<<1)+1]; 
       VESAhline_pstexture(lx1,lx2,i,tx1,ty1,nz1,tx2,ty2,nz2);
   }    
}

//
//                          PHONG TEXTURE-MAPPING
//

void VESAhline_ptexture(int x1,int x2,int y,int tx1,int ty1,int tx2,int ty2,int nx1,int ny1,int nx2,int ny2){
    int txp,txs,typ,tys,i,p,pixl,lum;
    int nxs,nys,nxp,nyp,nx,ny,r,g,b;
    if (x1==x2) return;
    if (x2<x1){ 
        swap(&x1,&x2);
        swap(&tx1,&tx2);
        swap(&ty1,&ty2);
        swap(&nx1,&nx2);
        swap(&ny1,&ny2);
    }
    txs=(tx2-tx1)/(x2-x1); txp=tx1;
    tys=(ty2-ty1)/(x2-x1); typ=ty1;
    nxs=(nx2-nx1)/(x2-x1); nxp=nx1;
    nys=(ny2-ny1)/(x2-x1); nyp=ny1;
    if (x1>clipx2) return;
    if (x2<clipx1) return;
    if (x1<clipx1){
        i=(clipx1-x1);
        txp+=i*txs;
        typ+=i*tys;
        nxp+=i*nxs;
        nyp+=i*nys;
        x1=clipx1;
    }
    if (x2>clipx2) x2=clipx2;
    p=(y*scrX)+x1;
    for (i=x1;i<x2;i++){
        nx=abs(nxp>>19);
        ny=abs(nyp>>19);
        pixl=_VESAtri.pic[((typ>>16)*256)+(txp>>16)];

        lum=specular[(((ny+128)*256)+nx+128)]<<6;
        r=rgb[((pixl&63488)>>10)+lum]>>1;
        g=rgb[((pixl&2016)>>5)+lum];
        b=rgb[((pixl&31)<<1)+lum]>>1;
        VESAbufrw[p++]=(r<<11)+(g<<5)+b;

        txp+=txs;
        typ+=tys;
        nxp+=nxs;
        nyp+=nys;
    }    
}

void VESAcalcslope_ptexture(int x1,int y1,int tx1,int ty1,int nx1,int ny1,
                            int x2,int y2,int tx2,int ty2,int nx2,int ny2,int add){
    int i,jmp,xp,xs,txp,txs,typ,tys,nxs,nys,nxp,nyp;
    if (y1>y2){ 
        swap(&y1,&y2);
        swap(&x1,&x2); 
        swap(&tx1,&tx2);
        swap(&ty1,&ty2); 
        swap(&nx1,&nx2);
        swap(&ny1,&ny2); 
    }
    if (y1==y2) if ((y1>clipy1)&&(y2<clipy2)){ 
        slope[y1<<1]=x1<<16; 
        slopetx[y1<<1]=tx1<<16; 
        slopety[y1<<1]=ty1<<16; 
        slopenx[y1<<1]=nx1<<16; 
        slopeny[y1<<1]=ny1<<16; 
        slope[(y1<<1)+1]=x2<<16; 
        slopetx[(y1<<1)+1]=tx2<<16; 
        slopety[(y1<<1)+1]=ty2<<16; 
        slopetx[(y1<<1)+1]=nx2<<16; 
        slopety[(y1<<1)+1]=ny2<<16; 
        return; 
    } else return;
    xs=((x2-x1)<<16)/(y2-y1); xp=x1<<16;
    txs=((tx2-tx1)<<16)/(y2-y1); txp=tx1<<16;
    tys=((ty2-ty1)<<16)/(y2-y1); typ=ty1<<16;
    nxs=((nx2-nx1)<<16)/(y2-y1); nxp=nx1<<16;
    nys=((ny2-ny1)<<16)/(y2-y1); nyp=ny1<<16;
//== clipping y =============================================================
    if (y1<clipy1){ 
        i=clipy1-y1; 
        y1=clipy1; 
        xp+=(xs*i); 
        txp+=(txs*i); 
        typ+=(tys*i); 
        nxp+=(nxs*i); 
        nyp+=(nys*i); 
    }
    if (y2>clipy2) y2=clipy2;
//===========================================================================
    if (miny>y1) miny=y1; if (maxy<y2) maxy=y2;
    for (i=y1;i<=y2;i++){
        slope[(i<<1)+add]=xp;
        slopetx[(i<<1)+add]=txp;
        slopety[(i<<1)+add]=typ;
        slopenx[(i<<1)+add]=nxp;
        slopeny[(i<<1)+add]=nyp;
        xp+=xs;
        txp+=txs;
        typ+=tys;
        nxp+=nxs;
        nyp+=nys;
    }
}

void VESAtri_ptexture(void){
   int i,add=0,lx1,lx2,tx1,ty1,tx2,ty2,nx1,ny1,nx2,ny2;
   miny=32768;
   maxy=-32768;
   if (_VESAtri.y2<_VESAtri.y1){ swap(&_VESAtri.y1,&_VESAtri.y2); swap(&_VESAtri.x1,&_VESAtri.x2); swap(&_VESAtri.tx1,&_VESAtri.tx2); swap(&_VESAtri.ty1,&_VESAtri.ty2); swap(&_VESAtri.nx1,&_VESAtri.nx2); swap(&_VESAtri.ny1,&_VESAtri.ny2); }
   if (_VESAtri.y3<_VESAtri.y1){ swap(&_VESAtri.y1,&_VESAtri.y3); swap(&_VESAtri.x1,&_VESAtri.x3); swap(&_VESAtri.tx1,&_VESAtri.tx3); swap(&_VESAtri.ty1,&_VESAtri.ty3); swap(&_VESAtri.nx1,&_VESAtri.nx3); swap(&_VESAtri.ny1,&_VESAtri.ny3); }
   if (_VESAtri.y3<_VESAtri.y2){ swap(&_VESAtri.y2,&_VESAtri.y3); swap(&_VESAtri.x2,&_VESAtri.x3); swap(&_VESAtri.tx2,&_VESAtri.tx3); swap(&_VESAtri.ty2,&_VESAtri.ty3); swap(&_VESAtri.nx2,&_VESAtri.nx3); swap(&_VESAtri.ny2,&_VESAtri.ny3); }
   if (_VESAtri.x2>_VESAtri.x3) add=1;
   VESAcalcslope_ptexture(_VESAtri.x1,_VESAtri.y1,_VESAtri.tx1,_VESAtri.ty1,_VESAtri.nx1,_VESAtri.ny1,_VESAtri.x2,_VESAtri.y2,_VESAtri.tx2,_VESAtri.ty2,_VESAtri.nx2,_VESAtri.ny2,add);
   VESAcalcslope_ptexture(_VESAtri.x2,_VESAtri.y2,_VESAtri.tx2,_VESAtri.ty2,_VESAtri.nx2,_VESAtri.ny2,_VESAtri.x3,_VESAtri.y3,_VESAtri.tx3,_VESAtri.ty3,_VESAtri.nx3,_VESAtri.ny3,add);
   VESAcalcslope_ptexture(_VESAtri.x3,_VESAtri.y3,_VESAtri.tx3,_VESAtri.ty3,_VESAtri.nx3,_VESAtri.ny3,_VESAtri.x1,_VESAtri.y1,_VESAtri.tx1,_VESAtri.ty1,_VESAtri.nx1,_VESAtri.ny1,add^1);
   for (i=miny;i<=maxy;i++){
       lx1=slope[i<<1]>>16; 
       lx2=slope[(i<<1)+1]>>16; 
       tx1=slopetx[i<<1]; 
       tx2=slopetx[(i<<1)+1]; 
       ty1=slopety[i<<1]; 
       ty2=slopety[(i<<1)+1]; 
       nx1=slopenx[i<<1]; 
       nx2=slopenx[(i<<1)+1]; 
       ny1=slopeny[i<<1]; 
       ny2=slopeny[(i<<1)+1]; 
       VESAhline_ptexture(lx1,lx2,i,tx1,ty1,tx2,ty2,nx1,ny1,nx2,ny2);
   }    
}

//
//                          TEXTURE-BUMP-MAPPING
//

void VESAhline_bptexture(int x1,int x2,int y,int tx1,int ty1,int tx2,int ty2,int nx1,int ny1,int nx2,int ny2){
    int txp,txs,typ,tys,i,p,pixl,lum,j,m;
    int nxs,nys,nxp,nyp;
    int bnx,bny,bc1,bc2,r,g,b,r1,g1,b1;
    unsigned int nx,ny;
    if (x1==x2) return;
    if (x2<x1){ 
        swap(&x1,&x2);
        swap(&tx1,&tx2);
        swap(&ty1,&ty2);
        swap(&nx1,&nx2);
        swap(&ny1,&ny2);
    }
    txs=(tx2-tx1)/(x2-x1); txp=tx1;
    tys=(ty2-ty1)/(x2-x1); typ=ty1;
    nxs=(nx2-nx1)/(x2-x1); nxp=nx1;
    nys=(ny2-ny1)/(x2-x1); nyp=ny1;
    if (x1>clipx2) return;
    if (x2<clipx1) return;
    if (x1<clipx1){
        i=(clipx1-x1);
        txp+=i*txs;
        typ+=i*tys;
        nxp+=i*nxs;
        nyp+=i*nys;
        x1=clipx1;
    }
    if (x2>clipx2) x2=clipx2;
    p=(y*scrX)+x1;
    for (i=x1;i<x2;i++){
        nx=(nxp>>20);//abs()
        ny=(nyp>>20);//abs()
        j=((typ>>16)<<8)+(txp>>16);
        pixl=_VESAtri.pic[j];
        bnx=_VESAtri.bumpmap[j+1]-_VESAtri.bumpmap[j-1];
        bny=_VESAtri.bumpmap[j+256]-_VESAtri.bumpmap[j-256];
        bc1=127-(bnx-nx);
        bc2=127-(bny-ny);
        if (bc1<0) bc1=0;
        if (bc2<0) bc2=0;

        lum=bmpspec[(bc2*256)+bc1]<<6;
        r=rgb[((pixl&63488)>>10)+lum]>>1;
        g=rgb[((pixl&2016)>>5)+lum];
        b=rgb[((pixl&31)<<1)+lum]>>1;
        VESAbufrw[p++]=(r<<11)+(g<<5)+b;

        txp+=txs;
        typ+=tys;
        nxp+=nxs;
        nyp+=nys;
    }    
}

void VESAcalcslope_bptexture(int x1,int y1,int tx1,int ty1,int nx1,int ny1,
                         int x2,int y2,int tx2,int ty2,int nx2,int ny2,int add){
    int i,jmp,xp,xs,txp,txs,typ,tys,nxs,nys,nxp,nyp,n;
    if (y1>y2){ 
        swap(&y1,&y2);
        swap(&x1,&x2); 
        swap(&tx1,&tx2);
        swap(&ty1,&ty2); 
        swap(&nx1,&nx2);
        swap(&ny1,&ny2); 
    }
    if (y1==y2) if ((y1>clipy1)&&(y2<clipy2)){ 
        slope[y1<<1]=x1<<16; 
        slopetx[y1<<1]=tx1<<16; 
        slopety[y1<<1]=ty1<<16; 
        slopenx[y1<<1]=nx1<<16; 
        slopeny[y1<<1]=ny1<<16; 
        slope[(y1<<1)+1]=x2<<16; 
        slopetx[(y1<<1)+1]=tx2<<16; 
        slopety[(y1<<1)+1]=ty2<<16; 
        slopetx[(y1<<1)+1]=nx2<<16; 
        slopety[(y1<<1)+1]=ny2<<16; 
        return; 
    } else return;
    xs=((x2-x1)<<16)/(y2-y1); xp=x1<<16;
    txs=((tx2-tx1)<<16)/(y2-y1); txp=tx1<<16;
    tys=((ty2-ty1)<<16)/(y2-y1); typ=ty1<<16;
    nxs=((nx2-nx1)<<16)/(y2-y1); nxp=nx1<<16;
    nys=((ny2-ny1)<<16)/(y2-y1); nyp=ny1<<16;
//== clipping y =============================================================
    if (y1<clipy1){ 
        i=clipy1-y1; 
        y1=clipy1; 
        xp+=(xs*i); 
        txp+=(txs*i); 
        typ+=(tys*i); 
        nxp+=(nxs*i); 
        nyp+=(nys*i); 
    }
    if (y2>clipy2) y2=clipy2;
//===========================================================================
    if (miny>y1) miny=y1; if (maxy<y2) maxy=y2;
    n=(y1<<1)+add;
    for (i=y1;i<=y2;i++){
        slope[n]=xp;
        slopetx[n]=txp;
        slopety[n]=typ;
        slopenx[n]=nxp;
        slopeny[n]=nyp;
        xp+=xs;
        txp+=txs;
        typ+=tys;
        nxp+=nxs;
        nyp+=nys;
        n+=2;
    }
}

void VESAtri_bptexture(void){
   int i,add=0,lx1,lx2,tx1,ty1,tx2,ty2,nx1,ny1,nx2,ny2,n;
   miny=32768;
   maxy=-32768;
   if (_VESAtri.y2<_VESAtri.y1){ swap(&_VESAtri.y1,&_VESAtri.y2); swap(&_VESAtri.x1,&_VESAtri.x2); swap(&_VESAtri.tx1,&_VESAtri.tx2); swap(&_VESAtri.ty1,&_VESAtri.ty2); swap(&_VESAtri.nx1,&_VESAtri.nx2); swap(&_VESAtri.ny1,&_VESAtri.ny2); }
   if (_VESAtri.y3<_VESAtri.y1){ swap(&_VESAtri.y1,&_VESAtri.y3); swap(&_VESAtri.x1,&_VESAtri.x3); swap(&_VESAtri.tx1,&_VESAtri.tx3); swap(&_VESAtri.ty1,&_VESAtri.ty3); swap(&_VESAtri.nx1,&_VESAtri.nx3); swap(&_VESAtri.ny1,&_VESAtri.ny3); }
   if (_VESAtri.y3<_VESAtri.y2){ swap(&_VESAtri.y2,&_VESAtri.y3); swap(&_VESAtri.x2,&_VESAtri.x3); swap(&_VESAtri.tx2,&_VESAtri.tx3); swap(&_VESAtri.ty2,&_VESAtri.ty3); swap(&_VESAtri.nx2,&_VESAtri.nx3); swap(&_VESAtri.ny2,&_VESAtri.ny3); }
   if (_VESAtri.x2>_VESAtri.x3) add=1;
   VESAcalcslope_bptexture(_VESAtri.x1,_VESAtri.y1,_VESAtri.tx1,_VESAtri.ty1,_VESAtri.nx1,_VESAtri.ny1,_VESAtri.x2,_VESAtri.y2,_VESAtri.tx2,_VESAtri.ty2,_VESAtri.nx2,_VESAtri.ny2,add);
   VESAcalcslope_bptexture(_VESAtri.x2,_VESAtri.y2,_VESAtri.tx2,_VESAtri.ty2,_VESAtri.nx2,_VESAtri.ny2,_VESAtri.x3,_VESAtri.y3,_VESAtri.tx3,_VESAtri.ty3,_VESAtri.nx3,_VESAtri.ny3,add);
   VESAcalcslope_bptexture(_VESAtri.x3,_VESAtri.y3,_VESAtri.tx3,_VESAtri.ty3,_VESAtri.nx3,_VESAtri.ny3,_VESAtri.x1,_VESAtri.y1,_VESAtri.tx1,_VESAtri.ty1,_VESAtri.nx1,_VESAtri.ny1,add^1);
   n=miny<<1;
   for (i=miny;i<=maxy;i++){
       lx1=slope[n]>>16; 
       lx2=slope[n+1]>>16; 
       tx1=slopetx[n]; 
       tx2=slopetx[n+1]; 
       ty1=slopety[n]; 
       ty2=slopety[n+1]; 
       nx1=slopenx[n]; 
       nx2=slopenx[n+1]; 
       ny1=slopeny[n]; 
       ny2=slopeny[n+1]; 
       VESAhline_bptexture(lx1,lx2,i,tx1,ty1,tx2,ty2,nx1,ny1,nx2,ny2);
       n+=2;
   }    
}

//
//                        GOURAUD TEXTURE-MAPPING
//

void VESAhline_gtexture(int x1,int x2,int y,int tx1,int ty1,int tx2,int ty2,int c1,int c2){
    int txp,txs,typ,tys,i,p,cp,cs,pixl,r,g,b,lum;
    if (x1==x2) return;
    if (x2<x1){
        swap(&x1,&x2);
        swap(&tx1,&tx2);
        swap(&ty1,&ty2);
        swap(&c1,&c2);
    }
    txs=(tx2-tx1)/(x2-x1); txp=tx1;
    tys=(ty2-ty1)/(x2-x1); typ=ty1;
    cs=(c2-c1)/(x2-x1); cp=c1;
    if (x1>clipx2) return;
    if (x2<clipx1) return;
    if (x1<clipx1){
        i=(clipx1-x1);
        cp+=i*cs;
        txp+=i*txs;
        typ+=i*tys;
        x1=clipx1;
    }
    if (x2>clipx2) x2=clipx2;
    p=(y*scrX)+x1;
    for (i=x1;i<x2;i++){
        pixl=_VESAtri.pic[(((typ>>16)<<8)+(txp>>16))]; 
        lum=(cp>>16)<<6;
        r=rgb[((pixl&63488)>>10)+lum]>>1;
        g=rgb[((pixl&2016)>>5)+lum];
        b=rgb[((pixl&31)<<1)+lum]>>1;
        VESAbufrw[p++]=(r<<11)+(g<<5)+b;

        txp+=txs;
        typ+=tys;
        cp+=cs;
    }    
}

void VESAcalcslope_gtexture(int x1,int y1,int tx1,int ty1,int c1,
                            int x2,int y2,int tx2,int ty2,int c2,int add){
    int i,jmp,xp,xs,txp,txs,typ,tys,cs,cp;
    if (y1>y2){
        swap(&y1,&y2);
        swap(&x1,&x2);
        swap(&tx1,&tx2);
        swap(&ty1,&ty2);
        swap(&c1,&c2);
    }
    if (y1==y2) if ((y1>clipy1)&&(y2<clipy2)){ 
        slope[y1<<1]=x1<<16; 
        slopec[y1<<1]=c1<<16; 
        slopetx[y1<<1]=tx1<<16; 
        slopety[y1<<1]=ty1<<16; 
        slope[(y1<<1)+1]=x2<<16; 
        slopec[(y1<<1)+1]=c2<<16; 
        slopetx[(y1<<1)+1]=tx2<<16; 
        slopety[(y1<<1)+1]=ty2<<16; 
        return; 
    } else return;
    xs=((x2-x1)<<16)/(y2-y1); xp=x1<<16;
    cs=((c2-c1)<<16)/(y2-y1); cp=c1<<16;
    txs=((tx2-tx1)<<16)/(y2-y1); txp=tx1<<16;
    tys=((ty2-ty1)<<16)/(y2-y1); typ=ty1<<16;
//== clipping y =============================================================
    if (y1<clipy1){
        i=clipy1-y1;
        y1=clipy1;
        xp+=(xs*i);
        txp+=(txs*i);
        typ+=(tys*i);
        cp+=(cs*i);
    }
    if (y2>clipy2) y2=clipy2;
//===========================================================================
    if (miny>y1) miny=y1; if (maxy<y2) maxy=y2;
    for (i=y1;i<=y2;i++){
        slope[(i<<1)+add]=xp;
        slopec[(i<<1)+add]=cp;
        slopetx[(i<<1)+add]=txp;
        slopety[(i<<1)+add]=typ;
        xp+=xs;
        cp+=cs;
        txp+=txs;
        typ+=tys;
    }
}

void VESAtri_gtexture(void){
   int i,add=0,lx1,lx2,tx1,ty1,tx2,ty2,c1,c2;
   miny=32768;
   maxy=-32768;
   if (_VESAtri.y2<_VESAtri.y1){ swap(&_VESAtri.y1,&_VESAtri.y2); swap(&_VESAtri.x1,&_VESAtri.x2); swap(&_VESAtri.tx1,&_VESAtri.tx2); swap(&_VESAtri.ty1,&_VESAtri.ty2); swap(&_VESAtri.c1,&_VESAtri.c2); }
   if (_VESAtri.y3<_VESAtri.y1){ swap(&_VESAtri.y1,&_VESAtri.y3); swap(&_VESAtri.x1,&_VESAtri.x3); swap(&_VESAtri.tx1,&_VESAtri.tx3); swap(&_VESAtri.ty1,&_VESAtri.ty3); swap(&_VESAtri.c1,&_VESAtri.c3); }
   if (_VESAtri.y3<_VESAtri.y2){ swap(&_VESAtri.y2,&_VESAtri.y3); swap(&_VESAtri.x2,&_VESAtri.x3); swap(&_VESAtri.tx2,&_VESAtri.tx3); swap(&_VESAtri.ty2,&_VESAtri.ty3); swap(&_VESAtri.c2,&_VESAtri.c3); }
   if (_VESAtri.x2>_VESAtri.x3) add=1;
   VESAcalcslope_gtexture(_VESAtri.x1,_VESAtri.y1,_VESAtri.tx1,_VESAtri.ty1,_VESAtri.c1,_VESAtri.x2,_VESAtri.y2,_VESAtri.tx2,_VESAtri.ty2,_VESAtri.c2,add);
   VESAcalcslope_gtexture(_VESAtri.x2,_VESAtri.y2,_VESAtri.tx2,_VESAtri.ty2,_VESAtri.c2,_VESAtri.x3,_VESAtri.y3,_VESAtri.tx3,_VESAtri.ty3,_VESAtri.c3,add);
   VESAcalcslope_gtexture(_VESAtri.x3,_VESAtri.y3,_VESAtri.tx3,_VESAtri.ty3,_VESAtri.c3,_VESAtri.x1,_VESAtri.y1,_VESAtri.tx1,_VESAtri.ty1,_VESAtri.c1,add^1);
   for (i=miny;i<=maxy;i++){
       lx1=slope[i<<1]>>16; 
       lx2=slope[(i<<1)+1]>>16; 
       tx1=slopetx[i<<1]; 
       tx2=slopetx[(i<<1)+1]; 
       ty1=slopety[i<<1]; 
       ty2=slopety[(i<<1)+1]; 
       c1=slopec[i<<1];
       c2=slopec[(i<<1)+1];
       VESAhline_gtexture(lx1,lx2,i,tx1,ty1,tx2,ty2,c1,c2);
   }    
}

/////////////////////////////////////////////////////////////////////////////
//////////////////////////////// z-buffer ///////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

//
//                            TEXTURE-MAPPING
//

void zVESAhline_texture(int x1,int x2,int y,int tx1,int ty1,int tx2,int ty2,int rz1,int rz2){
    int txp,txs,typ,tys,i,p;
    int rzs,rzp;
    if (x1==x2) return;
    if (x2<x1){
        swap(&x1,&x2);
        swap(&tx1,&tx2);
        swap(&ty1,&ty2);
        swap(&rz1,&rz2);
    }
    txs=(tx2-tx1)/(x2-x1); txp=tx1;
    tys=(ty2-ty1)/(x2-x1); typ=ty1;
    rzs=(rz2-rz1)/(x2-x1); rzp=rz1;
    if (x1>clipx2) return;
    if (x2<clipx1) return;
    if (x1<clipx1){
        i=(clipx1-x1);
        txp+=i*txs;
        typ+=i*tys;
        rzp+=i*rzs;
        x1=clipx1;
    }
    if (x2>clipx2) x2=clipx2;
    p=(y*scrX)+x1;
    for (i=x1;i<x2;i++){
        if (zbuffer[p]<=rzp){
            VESAbufrw[p]=_VESAtri.pic[(((typ>>16)*256)+(txp>>16))];
            zbuffer[p]=rzp;
        }
        p++;
        txp+=txs;
        typ+=tys;
        rzp+=rzs;
    }    
}

void zVESAcalcslope_texture(int x1,int y1,int z1,int tx1,int ty1,int x2,int y2,int z2,int tx2,int ty2,int add){
    int i,jmp,xp,xs,txp,txs,typ,tys;
    int zs,zp;
    if (y1>y2){
        swap(&y1,&y2);
        swap(&x1,&x2);
        swap(&z1,&z2);
        swap(&tx1,&tx2);
        swap(&ty1,&ty2);
    }
    if (y1==y2) if ((y1>clipy1)&&(y2<clipy2)){ 
        slope[y1<<1]=x1<<16; 
        slopez[y1<<1]=z1; 
        slopetx[y1<<1]=tx1<<16; 
        slopety[y1<<1]=ty1<<16; 
        slope[(y1<<1)+1]=x2<<16; 
        slopez[(y1<<1)+1]=z2; 
        slopetx[(y1<<1)+1]=tx2<<16; 
        slopety[(y1<<1)+1]=ty2<<16; 
        return; 
    } else return;
    xs=((x2-x1)<<16)/(y2-y1); xp=x1<<16;
    txs=((tx2-tx1)<<16)/(y2-y1); txp=tx1<<16;
    tys=((ty2-ty1)<<16)/(y2-y1); typ=ty1<<16;
    zs=((z2-z1))/(y2-y1); zp=z1;
//== clipping y =============================================================
    if (y1<clipy1){
        i=clipy1-y1;
        y1=clipy1;
        xp+=(xs*i);
        zp+=(zs*i);
        txp+=(txs*i);
        typ+=(tys*i);
    }
    if (y2>clipy2) y2=clipy2;
//===========================================================================
    if (miny>y1) miny=y1; if (maxy<y2) maxy=y2;
    for (i=y1;i<=y2;i++){
        slope[(i<<1)+add]=xp;
        slopez[(i<<1)+add]=zp;
        slopetx[(i<<1)+add]=txp;
        slopety[(i<<1)+add]=typ;
        xp+=xs;
        zp+=zs;
        txp+=txs;
        typ+=tys;
    }
}

void zVESAtri_texture(void){
   int i,add=0,lx1,lx2,tx1,tx2,ty1,ty2;
   int rz1,rz2,rz3;
   miny=32768;
   maxy=-32768;
   if (_VESAtri.y2<_VESAtri.y1){ swap(&_VESAtri.y1,&_VESAtri.y2); swap(&_VESAtri.x1,&_VESAtri.x2); swap(&_VESAtri.z1,&_VESAtri.z2); swap(&_VESAtri.tx1,&_VESAtri.tx2); swap(&_VESAtri.ty1,&_VESAtri.ty2); }
   if (_VESAtri.y3<_VESAtri.y1){ swap(&_VESAtri.y1,&_VESAtri.y3); swap(&_VESAtri.x1,&_VESAtri.x3); swap(&_VESAtri.z1,&_VESAtri.z3); swap(&_VESAtri.tx1,&_VESAtri.tx3); swap(&_VESAtri.ty1,&_VESAtri.ty3); }
   if (_VESAtri.y3<_VESAtri.y2){ swap(&_VESAtri.y2,&_VESAtri.y3); swap(&_VESAtri.x2,&_VESAtri.x3); swap(&_VESAtri.z2,&_VESAtri.z3); swap(&_VESAtri.tx2,&_VESAtri.tx3); swap(&_VESAtri.ty2,&_VESAtri.ty3); }
   if (_VESAtri.x2>_VESAtri.x3) add=1;
   rz1=fixdiv(65536,_VESAtri.z1); // 1/z est linaire aprs la projection
   rz2=fixdiv(65536,_VESAtri.z2);
   rz3=fixdiv(65536,_VESAtri.z3);
   zVESAcalcslope_texture(_VESAtri.x1,_VESAtri.y1,rz1,_VESAtri.tx1,_VESAtri.ty1,_VESAtri.x2,_VESAtri.y2,rz2,_VESAtri.tx2,_VESAtri.ty2,add);
   zVESAcalcslope_texture(_VESAtri.x2,_VESAtri.y2,rz2,_VESAtri.tx2,_VESAtri.ty2,_VESAtri.x3,_VESAtri.y3,rz3,_VESAtri.tx3,_VESAtri.ty3,add);
   zVESAcalcslope_texture(_VESAtri.x3,_VESAtri.y3,rz3,_VESAtri.tx3,_VESAtri.ty3,_VESAtri.x1,_VESAtri.y1,rz1,_VESAtri.tx1,_VESAtri.ty1,add^1);
   for (i=miny;i<=maxy;i++){
       lx1=slope[i<<1]>>16; 
       lx2=slope[(i<<1)+1]>>16; 
       tx1=slopetx[i<<1]; 
       tx2=slopetx[(i<<1)+1]; 
       ty1=slopety[i<<1]; 
       ty2=slopety[(i<<1)+1]; 
       rz1=slopez[(i<<1)];
       rz2=slopez[(i<<1)+1];
       zVESAhline_texture(lx1,lx2,i,tx1,ty1,tx2,ty2,rz1,rz2);
   }    
}
