#include "Copyright.h"
#include "Texture.h"
#include "File.h"




BTexture::BTexture (int width, int height) :
    m_width  (width),
    m_height (height),
    m_xmask  (width-1),
    m_ymask  (height-1),
    m_data   (new BCOLOR * [height])  {

    BASSERT (~(width -1) + width  == 0);
    BASSERT (~(height-1) + height == 0);

    for (int i=0; i<height; i++)
        m_data[i] = new BCOLOR [width];
}




BTexture::BTexture (const BTexture & texture) :
    m_width  (texture.m_width),
    m_height (texture.m_height),
    m_xmask  (texture.m_width-1),
    m_ymask  (texture.m_height-1),
    m_data   (new BCOLOR * [texture.m_height])  {

    for (int i=0; i<m_height; i++) {
        m_data[i] = new BCOLOR [m_width];
        for (int j=0; j<m_width; j++)
            m_data[i][j] = texture.m_data[i][j];
        }
}





BTexture::BTexture (const char * filename) {
    BFile file;
    BBYTE byte;
    BBYTE widthshift, heightshift;

    file.Open (filename);
    file.Read (& widthshift,  1);
    file.Read (& heightshift, 1);
    m_width  = 1 << widthshift;
    m_height = 1 << heightshift;
    m_xmask  = m_width  - 1;
    m_ymask  = m_height - 1;
    m_data   = new BCOLOR * [m_height];
    
    for (int i=0; i<m_height; i++) {
        m_data[i] = new BCOLOR [m_width];
        for (int j=0; j<m_width; j++) {
            file.Read (& byte, 1);
            m_data[i][j] = byte;
            }
        }

    file.Close ();
    return;
}


    


BTexture::~BTexture ()  {
    for (int i=0; i<m_height; i++)
        delete [] m_data[i];
    delete [] m_data;
}


