#include "Copyright.h"
#include "Timer.h"
#include "Variable.h"




BTimer * BTimer::m_instance = BNULL;




BTimer::BTimer () {
    BASSERT (m_instance == BNULL);
    m_instance = this;
    m_head     = BNULL;
}



BTimer::~BTimer () {
    BASSERT (m_head == BNULL);
    return;
}
    



void BTimer::Register (BVariable * var) {
    BASSERT (m_instance != BNULL);
    BASSERT (! var->m_registered);

    BUnit * newunit = new BUnit (var, m_instance->m_head, BNULL);
    if (m_instance->m_head != BNULL)
        m_instance->m_head->m_prev = newunit;
    m_instance->m_head = newunit;
    var->m_registered = BTRUE;
}



void BTimer::Unregister (BVariable * var) {
    BASSERT (m_instance != BNULL);
    BASSERT (var->m_registered);

    BUnit * p;
    for (p=m_instance->m_head; p!=BNULL; p=p->m_next) {
         BASSERT (p->m_var->m_registered);
         if (p->m_var == var) {
            var->m_registered = BFALSE;
            if (p->m_next != BNULL)
                p->m_next->m_prev = p->m_prev;
            if (p->m_prev != BNULL)
                p->m_prev->m_next = p->m_next;
            else {
                BASSERT (p == m_instance->m_head);
                m_instance->m_head = BNULL;
                }
            break;
            }
         }
}




void BTimer::Execute (int time) {
    BASSERT (m_instance != BNULL);
    for (BUnit * ptr=m_instance->m_head; ptr!=BNULL; ptr=ptr->m_next) {
         BASSERT (ptr->m_var->m_registered);
         ptr->m_var->OnTimer (time);
         }
}
