/*
    4d homogeneous coord. system vectors, 3d oriented functions
    by Jean-Francois Dube aka deks
    deks@videotron.ca, http://pages.infinit.net/deks
    
    5-19-97, 3:31 PM    started work log
*/

#ifndef _VECTOR_H_
#define _VECTOR_H_

#include "shared.h"
#include "matrix44.h"

#ifdef __cplusplus
extern "C" {
#endif

#define vectorCopy(v1,v2) repmovsd((byte *)v1, (byte *)v2, sizeof(vector)>>2);

typedef real vector[4];

void vectorSet(vector v, real x, real y, real z, real w);
void vectorPrint(vector v);
void vectorAdd(vector v1, vector v2, vector r);
void vectorSub(vector v1, vector v2, vector r);
void vectorDivide(vector v, real s, vector r);
real vectorLength(vector v);
void vectorNormalize(vector v, vector r);
void vectorMutiply(vector v, real s, vector r);
void vectorMultiplyByMatrix(vector v, matrix44 m, vector r);
real vectorDot(vector v1, vector v2);
void vectorCross(vector v1, vector v2, vector r);

#ifdef __cplusplus
}
#endif

#endif