#ifndef  _VECTOR_H
#define  _VECTOR_H


#ifndef  _BALDEF_H
#include "BalDef.h"
#endif





class BVector {
public:
    BREAL  x;
    BREAL  y;


    inline BVector () : x(0.0f), y(0.0f)  {}
    inline BVector (BREAL vx, BREAL vy) : x(vx),  y(vy)  {}
    inline BVector (const BVector & v)  : x(v.x), y(v.y) {}

    
    inline const BVector & operator = (const BVector & vec) {
        x = vec.x;  
        y = vec.y;  
        return * this;
        }



    inline BREAL Length () const
        {return BSQRT (x*x + y*y);}

    inline void Normalize () {
        BREAL len = Length ();
        x = x / len;
        y = y / len;
        }


    inline BVector operator + (const BVector & vec) const
        {return BVector (x+vec.x, y+vec.y);}

    inline BVector operator - (const BVector & vec) const
        {return BVector (x-vec.x, y-vec.y);}

    inline BVector operator - () const
        {return BVector (-x, -y);}

    inline BREAL   operator * (const BVector & vec) const
        {return x*vec.x + y*vec.y;}

    inline BVector operator * (BREAL num) const
        {return BVector (x*num, y*num);}

};



#endif
