#ifndef  _WALKER_H
#define  _WALKER_H


#ifndef  _BALDEF_H
#include "BalDef.h"
#endif

#ifndef  _POINT_H
#include "Point.h"
#endif

#ifndef  _VECTOR_H
#include "Vector.h"
#endif




class BSector;
class BCamera;
class BLine;




class BWalker {
friend class BCamera;

protected:
    BPoint          m_pos;
    BVector         m_normal;
    BREAL           m_height;
    const BSector * m_sector;


private:
    BBOOL SubWalk (const BVector & vector, 
                   const BSector * sector,
                   BREAL minbeta, const BLine * excline);


protected:
    BBOOL Walk (const BPoint  & newpos);
    void  Move (const BPoint  & newpos, const BSector * newsec);
    void  View (const BVector & newnormal);


public:
    BWalker (const BPoint  & pos,
             const BVector & normal,
             const BREAL     height,
             const BSector * sector);


};



#endif
    
