#include "Copyright.h"
#include "Painter.h"
#include "Buffer.h"
#include "File.h"




BPainter::BPainter (const BBuffer & buffer) : m_buffer (buffer) {

    int width  = buffer.Width  ();
    int height = buffer.Height ();
    BASSERT (width % 4 == 0);


    m_bmpinfo = (BITMAPINFO *) GlobalAlloc (GMEM_FIXED, 
        sizeof (BITMAPINFO) + 256 * sizeof (RGBQUAD));
    BASSERT (m_bmpinfo != NULL);

    m_bmpinfo->bmiHeader.biSize = sizeof (BITMAPINFOHEADER);
    m_bmpinfo->bmiHeader.biWidth = width;
    m_bmpinfo->bmiHeader.biHeight = height;
    m_bmpinfo->bmiHeader.biPlanes = 1;
    m_bmpinfo->bmiHeader.biBitCount = 8;
    m_bmpinfo->bmiHeader.biCompression = BI_RGB;
    m_bmpinfo->bmiHeader.biSizeImage = width * height;
    m_bmpinfo->bmiHeader.biXPelsPerMeter = 0;
    m_bmpinfo->bmiHeader.biYPelsPerMeter = 0;
    m_bmpinfo->bmiHeader.biClrUsed = 256;
    m_bmpinfo->bmiHeader.biClrImportant = 256;
    

    BBYTE pal [256 * 3];
    BFile file;
    file.Open  ("baltimore.pal");
    file.Read  (pal, 256 * 3);
    file.Close ();

    for (int i=0; i<256; i++) {
        m_bmpinfo->bmiColors [i].rgbRed   = pal[i*3];
        m_bmpinfo->bmiColors [i].rgbGreen = pal[i*3+1];
        m_bmpinfo->bmiColors [i].rgbBlue  = pal[i*3+2];
        }
}



BPainter::~BPainter () {
    GlobalFree ((HGLOBAL) m_bmpinfo);
    return;
}




BBOOL BPainter::Paint (HDC hdc, int x, int y) {
   return SetDIBitsToDevice (
        hdc, x, y,
        m_buffer.m_width, m_buffer.m_height, 
        0, 0, 0, m_buffer.m_height,
        (LPSTR) m_buffer.m_data,
        (LPBITMAPINFO) m_bmpinfo,
        DIB_RGB_COLORS) > 0;
}



