#include "Copyright.h"
#include "Painter.h"
#include "Buffer.h"





BPainter::BPainter (const BBuffer & buffer, Display * display) : 
    m_buffer  (buffer),
    m_image   (BNULL),
    m_display (display)  {

    int width  = buffer.Width  ();
    int height = buffer.Height ();
    BASSERT (width % 4 == 0);

    XVisualInfo  vinfo;
    Status  status = XMatchVisualInfo (display, DefaultScreen (display), 
                                       8, PseudoColor, & vinfo);
    BASSERT (status != 0);
    
    m_image = XCreateImage (display, vinfo.visual, 8, ZPixmap, 0, 
                            (char *) m_buffer.m_data,
                            width, height, 32, width);
    BASSERT (m_image != NULL);
    return;
}



BPainter::~BPainter () {
    XDestroyImage (m_image);
    return;
}



BBOOL BPainter::Paint (Window win, GC gc, int x, int y) {
    if (m_image == NULL)
        return BFALSE;
    XPutImage (m_display, win, gc, m_image, 0, 0, 
               x, y, m_buffer.m_width, m_buffer.m_height);
    return BTRUE;
}


